Graphics3D 640,480,16,0
SetBuffer BackBuffer()
;AmbientLight 0,0,0

SeedRnd MilliSecs()
HidePointer

Global campivot=CreatePivot()
PositionEntity campivot,0,0,0

Global campivot2=CreatePivot(campivot)
PositionEntity campivot2,0,35,0

Global camera=CreateCamera()
CameraClsMode camera,0,1
CameraRange camera,0.1,1000

Global chalev=1,chalevs=10

Dim chadata(10,8)
Data 0,1,-3,-3,60,1,-5,4
Data 0,1,1,1,60,2,100,1
Data 0,1,1,1,60,3,10,10
Data 0,1,1,1,60,4,1,15
Data 0,1,-3,-3,3,3,10,20
Data 0,1,1,1,60,4,50,7
Data 0,2,2,2,60,5,60,12
Data 0,2,2,2,60,2,100,9
Data 0,2,4,5,60,4,1,16
Data 0,2,2,2,60,3,0,17

For i=1 To chalevs
For j=1 To 8
Read chadata(i,j)
Next
Next


Dim wpow$(8)
wpow$(1)="Mouse Mania"
wpow$(2)="Cat Mania"
wpow$(3)="Place ^ again"
wpow$(4)="Everybody Move"
wpow$(5)="Mouse Monopoly"
wpow$(6)="Cat Attack"
wpow$(7)="Speed Up"
wpow$(8)="Slow Down"


Dim stage$(6)
stage$(1)="Get Mice"
stage$(2)="Run Away"
stage$(3)="Lunch Time"
stage$(4)="100 Mice"
stage$(5)="Cat Soccer"
stage$(6)="Domination"

Dim option$(4)
option$(1)="PLAY TIME (MINS)"
option$(2)="ANIMAL SPEED"
option$(3)="RATE OF EVENT MICE"
option$(4)="ARROW OVERWRITE"

Dim qrate$(4) ;no. of event mice (option)
qrate$(0)="None"
qrate$(1)="Few"
qrate$(2)="Normal"
qrate$(3)="Higher"
qrate$(4)="Highest"

Dim optset(4)
optset(1)=2 ;2 minute game default
optset(2)=3 ;average speed default
optset(3)=2 ;normal event mouse rate
Global opton=1
Global roundtime,gamespeed,eventrate
Global tot_rounds=3 ;number of rounds required to win in vs/team modes


Dim pltype$(3)
pltype$(1)="Human"
pltype$(2)="CPU"
pltype$(3)="None"
Global plook=1

Dim cputype$(6)
cputype$(1)="Weak"
cputype$(2)="Normal"
cputype$(3)="Tough"
cputype$(4)="Loves mice"
cputype$(5)="Hates cats"
cputype$(6)="Random"

Dim plcho(4),cpcho(4)
For i=1 To 4
plcho(i)=2 ;cpu
cpcho(i)=1 ;weak
Next
plcho(1)=1 ;human

load_opts()

Dim staged$(6)
staged$(1)="Lead all the Mice to the Goal"
staged$(2)="Avoid the Cat and reach the Goal"
staged$(3)="Feed the Cat with all the Mice"
staged$(4)="Collect 100 Mice within the time"
staged$(5)="Lead Cats into opponent's Goals"
staged$(6)="Defeat the opponent by 100 points"


Dim plname$(6)
plname$(1)="Player 1"
plname$(2)="Player 2"
plname$(3)="Player 3"
plname$(4)="Player 4"
plname$(5)="Team 1"
plname$(6)="Team 2"

Dim modename$(4,2)
modename$(0,1)="CHALLENGE"
modename$(0,2)="OPTIONS"
modename$(1,1)="VERSUS MODE"
modename$(1,2)="VERSUS EDIT"
modename$(2,1)="STAGE MODE"
modename$(2,2)="STAGE EDIT"
modename$(3,1)="PUZZLE MODE"
modename$(3,2)="PUZZLE EDIT"
modename$(4,1)="TEAM MODE"
modename$(4,2)="SURVIVAL"

Dim won(6) ;no. rounds won for each competitor in versus mode (0-3)

Dim survrec(25) ;survival records for the normal versus stages
Dim stagerec(25) ;best times for stage mode stages

For i=1 To 25
stagerec(i)=60
If i=25 Then stagerec(i)=120
Next

Dim passed(125) ;completed a puzzle or stage?
Global tpassed=0 ;number of puzzles passed
loadrecords()

Global tick=LoadImage("chumedia/tick.bmp")

Global startex=LoadTexture("chumedia/bigfield.png")
;Global startex=LoadTexture("alltexes/urb024.bmp")
ScaleTexture startex,1,1

Global space=CreateSphere()
PositionEntity space,0,0,0
ScaleEntity space,500,500,500
EntityTexture space,startex
FlipMesh space
EntityOrder space,10


HideEntity space



star=LoadImage("chumedia/star.bmp")

;arrays for calculate_normals() function
Dim Face_NX#(32768)
Dim Face_NY#(32768)
Dim Face_NZ#(32768)		
Dim Vertex_ConnectedTris(32768)
Dim Vertex_TriList(32768, 16)



Dim unplace(4),isplace(4)
Dim temp(4,2)
Dim troute(4,12,9) ;for swapping board info (everybody move)
Dim ikey(8)
Dim cplay(4),oplay(4) ;oplay remembers cplay (survival mode)


;cpu AI arrays
Dim route(4,12,9)
Dim arval(4,12,9,4) ;scores assigned to arrow placements for cpu
Dim arnew(4,4) ;proposed new arrow for each player to place
Dim archo(500,3) ;list of good choices for arrow placements
Dim arsco(4,3) ;scores relating to the currently placed arrows

Dim emoves(9,4) ;possible swaps for 'everybody move'
Data 2,1,4,3
Data 2,3,4,1
Data 2,4,1,3
Data 3,1,4,2
Data 3,4,1,2
Data 3,4,2,1
Data 4,1,2,3
Data 4,3,1,2
Data 4,3,2,1
For emo=1 To 9
For emp=1 To 4
Read emoves(emo,emp)
Next
Next


Dim catpos(10,5,3)
;10=no.cats, 5=lookahead, 3=x,y,dir

Dim mouseval(2)
mouseval(0)=5 ;normal mouse
mouseval(1)=50 ;50 mouse
mouseval(2)=30 ;? mouse

Dim posn(4) ;versus mode position (eg winning,2nd,3rd,4th)
;used to determine the likelihood of cpu attacking this opponent

Dim topsco(4) ;score of best move for each cpu player

Dim attack#(4) ;how important to attack an opponent?
attack(1)=0.3
attack(2)=0.2
attack(3)=0.15
attack(4)=0.1


Global stx#=0,sty#=0,stxx#=0,styy#=0
Global tux#=0,tuy#=0,tuxx#=0,tuyy#=0
Global tum#=0,tumm#=0
Global gotevent=0,basex=0,basey=0,initlock=0,ilx=0,ily=0
Global gametime=MilliSecs(),gamerem=0,puzbug=1,lcount=0
Global arhere=0 ;must be global for 'cat destroying arrows'
Global contype=1 ;0=keys, 1=mouse
Global cdist ;current distance from base (in cpulook)
Global etype ;1=cat, 2=mouse (in cpulook)
Global eventgot ;1-4 - who triggered an event?
Global dorefresh=0 ;refreshing map (titles)
Global rapid=0 ;accelerate time for puzzle solving
Global paused=0 ;in levtype_1, shows matches won
Global musc=0 ;music
Global teams=0 ;teams on or off ?
Global foes=0 ;number of active foes (for survival mode)
Global survival=0,beaten=0 ;survival mode on ?
Global challenge=0,chatime=0,cvictory=0 ;challenge mode on ?
Global gtype=0,gtarget=0 ;hold challenge mode info
Global surtime=0,rem_surtime=0,showclock=0
Global randomstage=0,watchtimer=0,watching=0
Global showesc=0,escount=0,factor#=0


;option - can arrows be placed on top of ones you've already placed?
;is handled by optset(4)


Global panning=0 ;camera pan at end of versus game
Global winner=0,didwin=0,xwinner=0,winscreen=0 ;the winner of a round
Global mode_t$ ;name of the currently selected mode
Global freeze=0 ;single variable for game state
Global totaltime=0 ;used to prevent messages appearing at start of round
Global trigger=0 ;go to next stage (pause menu into main control)
Global rocx=0,rocy=0,ryto=0 ;position of rocket icon

Global rem_gametime,rem_wontime


Global font1=LoadFont("helvetica",20)
Global font2=LoadFont("helvetica",60,True)
Global font3=LoadFont("helvetica",48,True)
Global font4=LoadFont("helvetica",20,True)
Global font5=LoadFont("helvetica",24)
Global font6=LoadFont("helvetica",36)
Global font7=LoadFont("helvetica",32)
Global font8=LoadFont("helvetica",72)

Global colortexture=CreateTexture(64,64)

SetBuffer TextureBuffer(colortexture)

tx=TextureWidth(colortexture)
ty=TextureHeight(colortexture)
dtx=tx/4
dty=ty/4

Dim tile$(6)
tile$(1)="WALLS"
tile$(2)="HOLES"
tile$(3)="BASES"
tile$(4)="MICE"
tile$(5)="CATS"
tile$(6)="SOLNS"

Dim topen(6)


Dim pdiff$(4)
pdiff$(1)="NORMAL"
pdiff$(2)="HARD"
pdiff$(3)="SPECIAL"
pdiff$(4)="MANIA"


Dim bcols(4,6)
Data 255,220,90,255,128,255
Data 255,128,0,0,180,230
Data 255,0,255,0,180,230
Data 0,230,230,0,210,64

For i=1 To 4
For j=1 To 6
Read bcols(i,j)
Next
Next

Dim brush(4,2)
For i=1 To 4
brush(i,1)=CreateBrush(bcols(i,1),bcols(i,2),bcols(i,3))
brush(i,2)=CreateBrush(bcols(i,4),bcols(i,5),bcols(i,6))
Next


Dim texcolors(16,3)
Data 255,255,255
Data 0,0,0
Data 0,0,255
Data 128,128,255
Data 255,255,0
Data 255,255,128
Data 255,0,0
Data 255,128,128
Data 0,255,0
Data 128,255,128
Data 128,128,128
Data 255,64,0
Data 255,128,64
Data 64,64,64
Data 0,0,0
Data 0,0,0

For mp=1 To 16
Read texcolors(mp,1)
Read texcolors(mp,2)
Read texcolors(mp,3)
Next


kg=1
For ke=0 To 3
For kd=0 To 3 
Color texcolors(kg,1),texcolors(kg,2),texcolors(kg,3)
Rect dtx*kd,dty*ke,dtx,dty
kg=kg+1
Next
Next

Global congrats=LoadImage("chumedia/congrats.bmp")

rovtex=LoadTexture("chumedia/roval.bmp",4)
maskit(rovtex,3)

fiftex=LoadTexture("chumedia/50.bmp",4)
maskit(fiftex,3)

qtex=LoadTexture("chumedia/quest.bmp",4)
maskit(qtex,3)

;screen signs
Global statex=LoadTexture("chumedia/startsign.bmp",4)
maskit(statex,3)
Global twomin=LoadTexture("chumedia/2minutes.bmp",4)
maskit(twomin,3)
Global onemin=LoadTexture("chumedia/1minute.bmp",4)
maskit(onemin,3)
Global thirty=LoadTexture("chumedia/30secs.bmp",4)
maskit(thirty,3)
Global three=LoadTexture("chumedia/three.bmp",4)
maskit(three,3)
Global two=LoadTexture("chumedia/two.bmp",4)
maskit(two,3)
Global one=LoadTexture("chumedia/one.bmp",4)
maskit(one,3)


uptex=LoadTexture("chumedia/fiftyup.bmp",4)
ouchtex=LoadTexture("chumedia/ouch.bmp",4)

Dim drocket(6)
drocket(0)=LoadImage("chumedia/greyrocket.bmp")
drocket(1)=LoadImage("chumedia/bluerocket.bmp")
drocket(2)=LoadImage("chumedia/yellowrocket.bmp")
drocket(3)=LoadImage("chumedia/redrocket.bmp")
drocket(4)=LoadImage("chumedia/greenrocket.bmp")
drocket(5)=LoadImage("chumedia/bluered.bmp")
drocket(6)=LoadImage("chumedia/yellowgreen.bmp")

For i=0 To 6
ScaleImage drocket(i),0.6,0.6
Next

Global crown=LoadImage("chumedia/crown.bmp")
ScaleImage crown,0.3,0.3

crowntex=LoadTexture("chumedia/crown.bmp",4)
maskit(crowntex,3)

SetBuffer BackBuffer()

Global fiftys=CreateSprite()
EntityTexture fiftys,fiftex
HideEntity fiftys

Global quests=CreateSprite()
EntityTexture quests,qtex
HideEntity quests

Global ssign=CreateSprite(camera)
EntityTexture ssign,statex
ScaleSprite ssign,2,1
HideEntity ssign


Global ups=CreateSprite()
EntityTexture ups,uptex
EntityOrder ups,-2
HideEntity ups

Global ouchs=CreateSprite()
EntityTexture ouchs,ouchtex
EntityOrder ouchs,-2
EntityAlpha ouchs,0.5
HideEntity ouchs

Global crow=CreateSprite()
EntityTexture crow,crowntex
EntityOrder crow,-1
ScaleSprite crow,1.5,1.2
HideEntity crow

Global ovpoint=CreateSprite()
EntityTexture ovpoint,rovtex
EntityOrder ovpoint,-2
ScaleSprite ovpoint,4,4
HideEntity ovpoint

Const aav#=0


Global options=3
Dim desop$(3)
desop$(1)="Change Red"
desop$(2)="Change Green"
desop$(3)="Change Blue"

Dim cpass(8)
Data 1,4,2,3
Data 1,3,4,2
For ii=1 To 8
Read cpass(ii)
Next

Dim initbase(4,2)
Data 1,1,12,9,12,1,1,9
For sa=1 To 4
Read initbase(sa,1)
Read initbase(sa,2)
Next

Dim initgen(4,3)
Data 5,4,3,8,4,4,5,6,3,8,6,4
For sa=1 To 4
Read initgen(sa,1)
Read initgen(sa,2)
Read initgen(sa,3)
Next

Global suse,start,finish,projx#,projy#,drag,dged,hcount,info
Global au=1,av=1,levtype=0 ;1=vs, 2=stage, 3=puzzle
Global use=1,odd=0,design=0,loadit=1,lockout=0,delmode=1
Global FileName$,message$,messtime,remfull=0,tileon=1,newit=0
Global levname$,testing=0,ovscale=0,scheme=0
Global subtype=0 ;for stage mode
Global modetype=0,inf$,signz#=0,signdz#=0
Global editmode=1 ;0 for editing main levels ;1 for custom levels
Global custom=0 ;if custom=1, working with custom maps

Global spdets=18

Dim spdet#(spdets,6)
;object sphere info
;1-5 =mice
;6-14 =bases
;15-18 =generators


Data 0,0,0,0.65,0.65,0.65
Data -0.6,0.65,0,0.4,0.4,0.4
Data 0.6,0.65,0,0.4,0.4,0.4
Data -0.2,0.25,-0.4,0.15,0.25,0.25
Data 0.2,0.25,-0.4,0.15,0.25,0.25
Data 0,-0.3,0.65,0.25,0.25,0.25

Data 0,0,0,2,0.25,2
Data 0,0.5,0,1.5,0.75,1.5
Data 0,0.7,0,1.2,0.6,1.2
Data 0,0,0.5,1,0.05,2

For mr=0 To spdets
If mr=6 Then mr=15
For ms=1 To 6
Read spdet(mr,ms)
Next
Next



spdet(6,4)=2:spdet(6,5)=2:spdet(6,6)=2

For ra=1 To 8
spdet(ra+6,1)=Sin(ra*45)
spdet(ra+6,2)=1.4
spdet(ra+6,3)=Cos(ra*45)
spdet(ra+6,4)=0.4
spdet(ra+6,5)=0.4
spdet(ra+6,6)=0.4
Next


Dim seen(1000)

Global sphere1=CreateSphere(8)
Global ssurf1=GetSurface(sphere1,1)
HideEntity sphere1

Global sphere2=CreateSphere(4)
Global ssurf2=GetSurface(sphere2,1)
HideEntity sphere2



Global squeak=LoadSound("chumedia/squeak.wav")
Global super50=LoadSound("chumedia/super50.wav")
Global explode=LoadSound("chumedia/explode.wav")
Global clunk=LoadSound("chumedia/clunk.wav")
Global error=LoadSound("chumedia/wrongans.wav")
Global atomic=LoadSound("chumedia/atomic.wav")

Global holetex=LoadTexture("chumedia/hole.bmp")
Global hole=CreateMesh()
Global hsurf=CreateSurface(hole)
simsurf(hsurf,2)
EntityTexture hole,holetex
HideEntity hole


Type dhole
Field ent,x,y
End Type

Type pic
Field ent,time,rem_time
End Type

Type mous
Field ent,x#,y#,face#,piv1,piv2,adjust,dead,faint#,special,sptext
Field xx#,yy#,magnet,nextx#,nexty#
End Type

Type catt
Field ent,x#,y#,face#,adjust,dead,faint#
Field xx#,yy#,magnet,nextx#,nexty#,destx,desty
Field anima
End Type

Type atomex
Field ent,light,extime
End Type

Type gener
Field ent,x,y,face
End Type

Type parrow
Field ent,x,y,face,used,size,damg
End Type

;blue base for puzzle and stage challenge
;can have as many as you want
Type pbase
Field ent,x,y,pulse,pulseon
End Type

Dim adva(4,2)
Data 0,-1,0,1,-1,0,1,0

For ks=1 To 4
Read adva(ks,1)
Read adva(ks,2)
Next

Dim try(4,3)
Data 4,3,2
Data 3,4,1
Data 1,2,4
Data 2,1,3
For tt=1 To 4
Read try(tt,1)
Read try(tt,2)
Read try(tt,3)
Next

Dim colname$(6)
colname$(1)="Blue"
colname$(2)="Yellow"
colname$(3)="Red"
colname$(4)="Green"
colname$(5)="Team 1"
colname$(6)="Team 2"

Dim basecol(6,3)
Data 0,0,255
Data 255,255,0
Data 255,0,0
Data 0,255,0
Data 0,0,255
Data 255,255,0
For mm=1 To 6
For nn=1 To 3
Read basecol(mm,nn)
Next
Next

Dim bbrush(4)
For ac=1 To 4
bbrush(ac)=CreateBrush(basecol(ac,1),basecol(ac,2),basecol(ac,3))
Next

Dim totarrows(4)

Dim ctrl(8)
Data 17,31,30,32,203,205,200,208
For gg=1 To 8
Read ctrl(gg)
Next

Dim arwho(12,9) ;0=none ;1=blue arrow ;etc
Dim ardir(12,9) ;0=none ;1=north arrow ;etc
Dim arin(4,3,5) ;arrow details
Dim rem_artime(4,3) ;remember arrow timer
Dim full(12,9) ;1 for bases and generators

Dim arrow(4)


For ka=1 To 4

arrow(ka)=CreateMesh()
EntityTexture arrow(ka),colortexture

px#=((ka*2) Mod 4)*0.25+0.12
py#=((ka*2)/4)*0.25+0.12


block=CreateSurface(arrow(ka))

simsurf2(block,2,px,py)

arr=CreateSurface(arrow(ka))

AddVertex arr,-0.5,0.1,1.6,0.12,0.12
AddVertex arr,0.5,0.1,1.6,0.12,0.12
AddVertex arr,-0.5,0.1,0,0.12,0.12
AddVertex arr,0.5,0.1,0,0.12,0.12

AddTriangle arr,0,1,2
AddTriangle arr,2,1,3

AddVertex arr,-1.2,0.1,0,0.12,0.12
AddVertex arr,1.2,0.1,0,0.12,0.12
AddVertex arr,0,0.1,-1.6,0.12,0.12

AddTriangle arr,4,5,6

HideEntity arrow(ka)

Next


Dim narrow(4,3) ;holds the arrow entities

For cc=1 To 4
For dd=1 To 3
narrow(cc,dd)=CopyEntity(arrow(cc))
HideEntity narrow(cc,dd)
;PositionEntity narrow(cc,dd),Rnd#(20)-10,5,Rnd#(20)-10
Next
Next


Dim basepos(4,2)
Data 1,5,2,5,3,5,4,5
For mm=1 To 4
Read basepos(mm,1)
Read basepos(mm,2)
full(basepos(mm,1),basepos(mm,2))=mm
Next

Dim pointpos#(4,2)


Dim pulse(4),pulseon(4),score(4),value(4),lscore(4),stall(4),urgent(4)
Dim exists(25) ;if a saved file exists

Const unit#=1
Global mouse_speed#=unit/10,cat_speed#=unit/15

Global frams=0,frate=MilliSecs(),tframs=0

Global my_timer=CreateTimer(60),event=0


basebase=CreateCylinder(16)
EntityColor basebase,0,0,0
ScaleEntity basebase,2.2,0.2,2.2
HideEntity basebase

Dim abase(4)
For i=1 To 4
abase(i)=CopyEntity(basebase)
HideEntity abase(i)
Next


Dim bpoint(4)

For md=1 To 4
bpoint(md)=CreateMesh()
EntityTexture bpoint(md),colortexture

psurf=CreateSurface(bpoint(md))

AddVertex(psurf,0,0,0,0.12,0.12)
AddVertex(psurf,2.5,0,-1.5,0.12,0.12)
AddVertex(psurf,0.5,0,-3,0.12,0.12)
AddTriangle(psurf,0,1,2)

px#=((md*2) Mod 4)*0.25+0.12
py#=((md*2)/4)*0.25+0.12

AddVertex(psurf,0.2,0.1,-0.2,px,py)
AddVertex(psurf,2.3,0.1,-1.5,px,py)
AddVertex(psurf,0.6,0.1,-2.8,px,py)
AddTriangle(psurf,3,4,5)

PositionEntity bpoint(md),0,5,md*4
EntityOrder bpoint(md),-5

Next





;make gen point


Global genpoint=CreateMesh()
Global genbody=CreateSurface(genpoint)
EntityTexture genpoint,colortexture
start=15
finish=18

For wa=start To finish
suse=ssurf1
newsphere(wa,genbody,spdet(wa,1),spdet(wa,2),spdet(wa,3),spdet(wa,4),spdet(wa,5),spdet(wa,6),wa-4)
Next

HideEntity genpoint

For ks=1 To 4
gn.gener=New gener
gn\ent=CopyEntity(genpoint)
RemGen=Handle(gn)
Next


;make base
Global baseverts=0

Dim bases(5),basesurf(5)

For nb=1 To 5
;5 is another blue base for copying
nbb=nb
If nbb=5 Then nbb=1

bases(nb)=CreateMesh()
basesurf(nb)=CreateSurface(bases(nb))
EntityTexture bases(nb),colortexture

start=6
finish=14

For wa=start To finish
If wa=6 Then suse=ssurf1 Else suse=ssurf2
If wa=6 Then texon=nbb*2+1 Else texon=nbb*2+2

newsphere(wa,basesurf(nb),spdet(wa,1),spdet(wa,2),spdet(wa,3),spdet(wa,4),spdet(wa,5),spdet(wa,6),texon,0)

If wa=start Then baseverts=CountVertices(basesurf(nb))

Next

HideEntity bases(nb)

Next

Dim bcrown(4)
For i=1 To 4
;crowns signifying a lead for each player in versus mode
bcrown(i)=CopyEntity(crow)
EntityParent(bcrown(i),bases(i))
PositionEntity bcrown(i),1.5,0,1.5
HideEntity bcrown(i)
Next

Global exptex=LoadTexture("chumedia/exptex.bmp")

Global atom=CreateSphere(4) ;sphere explosion for survival mode
EntityTexture atom,exptex
HideEntity atom
;size will increase and alpha decrease, based on time since explosion
;so no point defining them now


Global basemode=0

;Dim light(5,5)
Global light=CreateLight()
PositionEntity light,4,20,4

Global light2=CreateLight(2)
PositionEntity light2,4,-5,4
;makes sure the skysphere is visible in all directions
;needed when panning around the board at the end



;make cat
;currently a placeholder

Global cat=LoadAnimMesh("chumedia/kapukapu.b3d")


EntityShininess cat,1
HideEntity cat

animation = FindChild(cat, "kapukapu")
Animate(animation, 1, 0.5)

ScaleEntity(cat, 0.05, 0.05, 0.05)

;start=19
;finish=20
;suse=ssurf1
;newsphere(19,cbody,0,0,0,1.6,2,1.6,5,2.5)
;newsphere(20,cbody,0,0,-1,0.5,0.5,2,6,2.5)

PositionEntity cat,4,2.5,0

;make mouse
Global mouse=CreateMesh()
Global body=CreateSurface(mouse)
EntityTexture mouse,colortexture
EntityShininess mouse,1

start=0
finish=4

For wa=start To finish
;If wa=1 Then suse=ssurf1
suse=ssurf2
tpick=1
If wa=1 Or wa=2 Or wa=5 Then tpick=3
If wa=3 Or wa=4 Then tpick=2
newsphere(wa,body,spdet(wa,1),spdet(wa,2),spdet(wa,3),spdet(wa,4),spdet(wa,5),spdet(wa,6),tpick,1)
Next



Global pivot1=CreatePivot(mouse)
PositionEntity pivot1,-0.5,0.9,0

Global pivot2=CreatePivot(mouse)
PositionEntity pivot2,0.5,0.9,0

foot=newpart(1,3,3,0.3,0.25,0.6,0,-1.5,0)
foot=newpart(1,4,3,0.3,0.25,0.6,0,-1.5,0)


HideEntity mouse


Global grid=CreateMesh()
EntityOrder grid,0
Global gsurf1,gsurf2

gsurf1=newsurface(0)
gsurf2=newsurface(4)

PositionEntity grid,4,0,4

calculate_normals(grid)

Global wallmesh=CreateMesh()
Global wsurf=CreateSurface(wallmesh)

;build the surface of walls
;note - when initialised, the vertex positions
;ensure that the triangles will be underneath,
;meaning that each wall is 'off'
;changing the vertex positions will make a wall
;segment visible
Global wthic#=0.25

;vertical segments
For ah=0 To 12
For ai=1 To 9

posx=ah*4-20
posy=22-ai*4

AddVertex(wsurf,posx+wthic,0,posy-0.2)
AddVertex(wsurf,posx-wthic,0,posy-0.2)
AddVertex(wsurf,posx+wthic,0,posy+4.2)
AddVertex(wsurf,posx-wthic,0,posy+4.2)

cc=CountVertices(wsurf)

AddTriangle(wsurf,cc-4,cc-2,cc-3)
AddTriangle(wsurf,cc-2,cc-1,cc-3)
;AddTriangle(wsurf,cc-4,cc-3,cc-2)
;AddTriangle(wsurf,cc-2,cc-3,cc-1)


Next
Next


;horizontal segments
For ai=0 To 9
For ah=1 To 12

posx=ah*4-24
posy=22-ai*4

AddVertex(wsurf,posx-0.2,0,posy+wthic)
AddVertex(wsurf,posx-0.2,0,posy-wthic)
AddVertex(wsurf,posx+4.2,0,posy+wthic)
AddVertex(wsurf,posx+4.2,0,posy-wthic)

cc=CountVertices(wsurf)

AddTriangle(wsurf,cc-4,cc-3,cc-2)
AddTriangle(wsurf,cc-2,cc-3,cc-1)
;AddTriangle(wsurf,cc-4,cc-2,cc-3)
;AddTriangle(wsurf,cc-2,cc-1,cc-3)


Next
Next

PositionEntity wallmesh,0,0.1,0

;EntityColor wallmesh,0,0,192

Dim wall(13,10,4) ;1=north ;2=south ;3=west ;4=east
Dim remwall(13,10,4)



;wheel texture


Dim wpcol(8,3)
Data 255,64,255
Data 0,255,255
Data 255,160,64
Data 255,255,0
Data 255,128,255
Data 0,255,0
Data 255,0,0
Data 128,0,255
For mc=1 To 8
For md=1 To 3
Read wpcol(mc,md)
Next
Next


wheeltex=CreateTexture(360,480)
SetBuffer TextureBuffer(wheeltex)

wwidth#=TextureWidth(wheeltex)
wheight#=TextureHeight(wheeltex)

tright#=360/wwidth
tdown#=60/wheight

For ka=1 To 8

SetFont font2
down=0
If ka=4 Or ka=5 Then SetFont font3
If ka=4 Or ka=5 Then down=5

Color wpcol(ka,1),wpcol(ka,2),wpcol(ka,3)
Rect 0,60*ka-60,360,60

Color 0,0,0
Text 178-StringWidth(wpow$(ka))/2,60*ka+down-62,wpow$(ka)

Color 255,255,255
Text 180-StringWidth(wpow$(ka))/2,60*ka+down-60,wpow$(ka)
Next

SetBuffer BackBuffer()

;wheel mesh
Global wheel=CreateMesh(camera)
Global whsurf=CreateSurface(wheel)
Global wheelat#=0,waccel#=-5,wontime=0
Global wclunk=0,wheelrot=0
;Global light3=CreateLight(1,camera)


For gt=0 To 8

AddVertex(whsurf,-5,Sin(gt*45)*2,Cos(gt*45)*2,0,tdown*gt)
AddVertex(whsurf,5,Sin(gt*45)*2,Cos(gt*45)*2,tright,tdown*gt)

If gt>0
AddTriangle(whsurf,gt*2-2,gt*2-1,gt*2)
AddTriangle(whsurf,gt*2,gt*2-1,gt*2+1)
EndIf

Next



;PositionEntity wheel,0,28,1
EntityTexture wheel,wheeltex
EntityOrder wheel,-8
HideEntity wheel

RotateEntity wheel,-22,0,0

calculate_normals(wheel)

Global mwalk#=0,mwch#=1,mlimit=30,mice=0,cats=0

Dim sfxs(100)


Global ingame=0,tpage=1,chx=1,chy=1,puzd=1,boardnum=0


newboard()


HideEntity grid
HideEntity wallmesh
For ka=1 To 4
HideEntity bpoint(ka)
Next

;show when ingame=1 and levtype=1
;hide at other times

For gb=1 To 4
HideEntity bases(gb)
Next

For gr.gener=Each gener
HideEntity gr\ent
Next


For i=1 To 2
osurf=GetSurface(grid,i)
PaintSurface osurf,brush(1,i)
Next

watchtimer=MilliSecs()

.game_loop
Repeat

update_camera()

If ingame=0 Then titles()
If ingame=1 Then game()

WaitTimer my_timer

Flip
Cls

Until False

End



Function game()

If KeyHit(2) Then savescreenshot()


If wheelat<1
ofactor#=factor#
factor#=1 ;governs speed (speed up and slow down)
If event=7 Then factor#=2
If event=8 Then factor#=0.5

If ofactor<>factor Then animcats(1) ;change cat walking speed
EndIf

If watching=1

watchout=0
If KeyHit(1) Then watchout=1
If totaltime-(gametime-MilliSecs())>20000 Then watchout=1

If watchout=1
backtomenu()
Return(0)
EndIf
EndIf

If levtype=1 And design=0
If challenge=0 Or testing>0
If ChannelPlaying(musc)=False
musc=PlayMusic("chumedia/chuchu.it")
EndIf
EndIf
EndIf


freeze=1
If testing=1 And paused=0 And wheelat<1 And event<>4 Then freeze=0

If survival=1 And freeze=0 And panning=0 Then do_survival()

If freeze=0 Then extras() ;bomb explosions etc

If levtype=1
If testing=0 Or showclock=1
If paused=0 And wheelat<1 Then signs()
EndIf
EndIf


If panning=1 And paused=0 Then camera_pan()

allow=1 ;pause menu active from here?
If xwinner<>0 Or watching=1 Then allow=0
If panning=1 And rocy>ryto Then allow=0
If design=1 Then allow=0
;If levtype=2 And testing>0 Then allow=0
;If levtype=3 And testing>0 Then allow=0


If allow=1 Then pause_stuff()

If xwinner>0
gonext=0
If KeyHit(1) Then gonext=1
If MouseHit(1) Then gonext=1
If KeyHit(28) Then gonext=1

If winscreen=0 And gonext=1
gonext=0
clearboard()
EndIf

If winscreen=1 And gonext=1
backtomenu()
EndIf

EndIf

If wheelat<1 And paused=0 And panning=0 And event<>6 Then pointerstuff()
If paused=0 Then basepulse()


If event>0 And wheelat<1 And wontime<MilliSecs() Then eventend()


If freeze=0

If levtype<3 Then arrowstuff()

If event<>3 And event<>4 And event<>6
If modetype=1 And panning=0 Then generators()
mousestuff()
catstuff()
If rapid=1
;accelerate time by doing these 
;functions twice each frame
mousestuff()
catstuff()
EndIf
EndIf

If event=6 Then catstuff() ;handles cat attack

eatmouse()
If modetype=1 Then picstuff()

If teams=1
score(3)=score(1)
score(4)=score(2)
EndIf

lcount=lcount+1
If lcount>=5 Then lcount=0

If design=0 And lcount=0
If levtype=1 Or subtype>4
cpulook() ;AI test
EndIf
EndIf

If winner=0 And testing<2
result()
EndIf

EndIf


If event=4 And wheelat<1 And paused=0 Then everymove()

If paused=0 And wheelat>1 Then dowheel()

If design=1 Then leveldesign()

If testing=3 And ovscale>4
ovscale=ovscale-1
ScaleSprite ovpoint,ovscale,ovscale
EndIf

backstuff()


UpdateWorld()
RenderWorld()

If freeze=1 Or event=3 Or event=6 Or panning=1
fix_timers()
Else
If showclock=0 Then gametime=MilliSecs()+rem_gametime ;for survival
EndIf

If winscreen=0 Then textstuff()
If winscreen=1 Then winstuff()
If design=1 Then leveltext()
If paused=0 Then maincontrol()


End Function


Function newpart(shape,parent,colour,xscal#,yscal#,zscal#,xpos#,ypos#,zpos#)
If parent=1 Then parent=body
If parent=2 Then parent=nose
If parent=3 Then parent=pivot1
If parent=4 Then parent=pivot2
If shape=1 Then part=CreateSphere(4,parent)
If shape=2 Then part=CreateCube(parent)
If colour=1 Then EntityColor part,64,64,255
If colour=2 Then EntityColor part,0,0,0
If colour=3 Then EntityColor part,192,192,255
ScaleEntity part,xscal#,yscal#,zscal#
PositionEntity part,xpos#,ypos#,zpos#
 
Return(part)
End Function


Function newmouse(xpos,ypos,facing,init=0)

If design=1 Then full(xpos,ypos)=8+facing

mice=mice+1
;DebugLog(xpos+" "+ypos)

m.mous=New mous
m\ent=CopyEntity(mouse)
m\x=xpos
m\y=ypos
m\face=facing
If init=1 Then initmouse(m.mous)

m\special=0
m\adjust=0
m\magnet=0

specrnd=0

If design=0
If levtype=1 Or subtype=6
specrnd=Int(Rnd#(100)+0.5)
EndIf
EndIf


If specrnd=1 Then m\special=1 ;worth 50
If specrnd>1 And specrnd<=eventrate+1 Then m\special=2 ;event mouse



If event>0 And m\special=2 Then m\special=0


If m\special=1
m\sptext=CopyEntity(fiftys,m\ent)
PositionEntity m\sptext,0,2,0
EndIf

If m\special=2
m\sptext=CopyEntity(quests,m\ent)
PositionEntity m\sptext,0,2,0
EndIf

m\piv1=GetChild(m\ent,1)
m\piv2=GetChild(m\ent,2)

PositionEntity m\ent,xpos*4-22,1,24-ypos*4
adjust(m\ent,m\face)

calculate_normals(m\ent)

End Function

Function newcat(xpos,ypos,facing,magp=0,init=0)

If design=1 Then full(xpos,ypos)=12+facing

cats=cats+1

c.catt=New catt
c\ent=CopyEntity(cat)
c\x=xpos
c\y=ypos
c\face=facing
c\faint=0
c\magnet=0
If init=1 Then initcat(c.catt)

c\adjust=0

If magp>0
c\magnet=1
c\destx=basepos(magp,1)
c\desty=basepos(magp,2)
EndIf

PositionEntity c\ent,xpos*4-22,1,24-ypos*4
adjust(c\ent,c\face)
calculate_normals(c\ent)

c\anima = FindChild(c\ent, "kapukapu")
If init=1 Then Animate(c\anima, 1,cat_speed*factor*7)


End Function



Function textstuff()

Local prx=Int(projx),pry=Int(projy)

If watching=1

escount=escount+1
If escount=20 Then escount=0:showesc=1-showesc

If showesc=1

Color 255,255,255
SetFont font7
Text 252,188,"PRESS ESCAPE"

EndIf

EndIf

;Text 10,200,route(1,prx,pry)
If panning=0
If paused=0 Or levtype>1
SetFont font3
Color 255,255,0
Text 10,350,"stage"
SetFont font6
Color 255,255,255
If challenge=0 Then Text 45,390,display$(boardnum)
If challenge=1 Then Text 45,390,display$(chalev)
EndIf
EndIf

doname=0
If levtype=3 Or design=1 Then doname=1
If levtype=2 And testing>0 Then doname=1

If doname=1
Color 255,255,255
Rect 330,370,220,30

Color 128,0,128
Rect 329,369,222,32,False
Rect 328,368,224,34,False

Color 0,0,0
SetFont font5
Text 338,372,levname$
EndIf

If levtype=3
SetFont font5

Color 255,255,255
Rect 10,320,110,25

Color 0,0,128
Rect 10,320,110,27,False
Rect 11,321,108,25,False

Color 0,0,0
Text 65-StringWidth(pdiff$(puzd))/2,322,pdiff$(puzd)
EndIf


SetFont font1

Color 255,255,255

If levtype=1 And design=0
EndIf

;Text 10,200,ardir(Int(projx),Int(projy))
;Text 10,230,totarrows(1)

frams=frams+1	
	If MilliSecs()-frate>1000
	frate=frate+1000
	tframs=frams
	frams=0
	EndIf


Color 255,255,255
Text 20,440,"FPS = "+tframs


If design=0

;Text 20,290,"No. Mice = "+mice
;Text 20,310,"FPS = "+tframs
;Text 20,330,"Tris = "+TrisRendered()
showclock=1
If survival=1 Then showclock=0
If challenge=1
If gtype=2 Then showclock=0
If gtype=5 Then showclock=1
EndIf


If levtype<>3 And showclock=1

If panning=0
;draw timer

Color 128,128,192
Rect 10,20,100,90

Color 0,0,192
Rect 12,22,100,90

Color 255,200,100
Oval 25,30,70,70

Color 0,0,0
Oval 30,35,60,60

Color 255,255,255
SetFont font7
Text 34,47,clocker$((gametime+990-MilliSecs())/1000)

EndIf



If levtype=1 And survival=0 And challenge=0 And gametime<MilliSecs() And panning=0

wcount=0
For i=1 To 4
If posn(i)=1
wcount=wcount+1
If teams=0 Or i<3 Then winner=i
EndIf
Next


If wcount=teams+1 ;someone is winning out-right

;won(winner)=won(winner)+1 ;for team mode, winner can be 1 or 2
rocx=winner*160-150

If teams=1 And winner=1 Then rocx=164
If teams=1 And winner=2 Then rocx=334

rocy=480 ;position of rocket icon
didwin=winner
PlaySound atomic

If teams=1 Then winner=winner+4

For i=1 To 4
failed=0
If teams=0 And i<>winner Then failed=1
If teams=1 And (i Mod 2)<>(winner Mod 2) Then failed=1
If failed=1
HideEntity bases(i)
new_atom(basepos(i,1),basepos(i,2))
EndIf
Next
 

inf$=colname$(winner)
If teams=0 Then inf$=inf$+" ("+name$(winner)+")"
inf$=inf$+" wins!!!"
into_pan()

EndIf

EndIf

EndIf

sboards=0
If levtype=1 Then sboards=4
If levtype=2 And subtype=4 Then sboards=1
If teams=1 Then sboards=2

If paused=1

lxp=132

SetFont font6
Color 0,0,0
Rect lxp,150,450,35
Rect lxp,200,450,35
Rect lxp,250,450,35
Color 255,255,255
Rect lxp,150,450,35,False
If panning=0 Then Text lxp+25,150,"RESUME = (L-MOUSE)"
If panning=1 Then Text lxp+25,150,"PLAY NEXT = (L-MOUSE)"
Rect lxp,200,450,35,False

;same effect - restart the current level again
If panning=0 Then Text lxp+25,200,"RESTART = (R-MOUSE)"
If panning=1 Then Text lxp+25,200,"PLAY SAME = (R-MOUSE)"

Rect lxp,250,450,35,False
Text lxp+25,250,"END GAME = (ESCAPE)"

EndIf


If panning=1 And challenge-survival>=0
Color 0,0,0
Rect 0,0,640,48
Color basecol(winner,1),basecol(winner,2),basecol(winner,3)
SetFont font3
Text 320-StringWidth(inf$)/2,0,inf$
EndIf


If paused=1 Or panning=1

zup=0
If panning=1 And teams=0 Then zup=80
If panning=1 And teams=1 Then zup=100
If challenge=1 Then zup=0

If levtype=1 ;rounds won - only in versus mode

If survival=1
SetFont font3
Color 32,32,32
Rect 150,400,400,45
Color 255,255,255
inf2$="SURVIVED = "+beaten
Text 350-StringWidth(inf2$)/2,400,inf2$
EndIf

If teams=0 And survival=0 And challenge+paused<2

.scorebars
If challenge=0 Then zat=456 Else zat=380

For i=1 To 4


Color basecol(i,1),basecol(i,2),basecol(i,3)
Rect i*160-160,375-zup,160,105+zup
Color 0,0,0
Rect i*160-150,zat-zup,140,20
Rect i*160-160,375-zup,160,105,False

If challenge=0 Then round_info(i,i*160-150,385-zup)

If challenge=1 Then SetFont font5
Color 255,255,255
Text i*160-80-StringWidth(name$(i))/2,zat-zup,name$(i)


If panning=1
Color 0,0,0
Rect i*160-150,405,140,70
Color 255,255,255
SetFont font8
textscore(score(i),i*160-60,405,40)
EndIf

Next

EndIf


If teams=1

rquad(0,380-zup,1)
rquad(320,380-zup,2)
rquad(0,430-zup,3)
rquad(320,430-zup,4)

round_info(5,164,400-zup)
round_info(6,334,400-zup)

If panning=1
rquad(0,380,1)
rquad(320,380,2)
rquad(0,430,3)
rquad(320,430,4)
Color 0,0,0
Rect 0,379,640,2
Rect 170,395,140,70
Rect 330,395,140,70
Color 255,255,255
SetFont font8
textscore(score(1),260,395,40)
textscore(score(2),420,395,40)
EndIf


EndIf

EndIf

EndIf

.score_panels

dopanels=0
If testing>0 Then dopanels=1
If levtype=1 And challenge=0 Then dopanels=1

If dopanels=1
;draw the score panels
If sboards>0 And sboards<>2 And paused=0 And panning=0

If survival=1
Color 255,255,255
SetFont font7
textscore(beaten,360,445,15,0)
EndIf


SetFont font2

For mc=1 To sboards

If cplay(mc)>-3

Color basecol(mc,1),basecol(mc,2),basecol(mc,3)
Rect mc*114+12,370,110,70

Color 0,0,0
Rect mc*114+16,373,102,15
SetFont font4
Color 255,255,255
Text mc*114+25,372,name$(mc)
SetFont font2


Color 0,0,0
Rect mc*114+15,390,104,47

Color 255,255,255
Rect mc*114+11,369,112,72,False

textscore(score(mc),mc*114+82,384,30)

If posn(mc)>1 Then HideEntity bcrown(mc)
If score(mc)>0 And posn(mc)=1
DrawImage crown,mc*114+90,371
ShowEntity bcrown(mc)
EndIf

EndIf

Next

EndIf


If sboards=2 And paused=0 And panning=0;for team mode

quadrant(130,370,1)
quadrant(130,405,3)
quadrant(350,370,2)
quadrant(350,405,4)

Color 0,0,0
Rect 220,380,120,50
Rect 360,380,120,50
Color 255,255,255

SetFont font2
textscore(score(1),295,377,30)
textscore(score(2),435,377,30)
EndIf

If rocy>ryto ;new rocket icon comes in

DrawImage drocket(winner),xmap(rocx,won(didwin)+1),rocy
rocy=rocy-2
If rocy<=ryto
won(winner)=won(winner)+1
FlushKeys()
FlushMouse()
If won(winner)=tot_rounds Then xwinner=winner
EndIf
EndIf


EndIf


If challenge=1 And testing=0

If paused=0 Then toptext("Press Mouse (1) to Run")

chall$="CHALLENGE "+chalev
If gtype=1 Then cinfo$="Open a gap of "+gtarget+" points"
If gtype=2 Then cinfo$="Be the first to "+gtarget+" points"
If gtype=3 Then cinfo$="Complete "+gtarget+" survivals"
If gtype=4 And gtarget=1 Then cinfo$="Win the match"
If gtype=4 And gtarget>1 Then cinfo$="Win the match by "+gtarget+" points"
If gtype=5 Then cinfo$="Survive until the time expires"

Color wpcol(gtype,1)*0.5,wpcol(gtype,2)*0.5,wpcol(gtype,3)*0.5
Rect 210,370,270,80
Color 255,255,255
Rect 210,370,270,80,False
SetFont font6
Text 345-StringWidth(chall$)/2,375,chall$
SetFont font5
Text 345-StringWidth(cinfo$)/2,420,cinfo$

EndIf



If levtype=2
SetFont font5
If testing=0
toptext("Press Mouse (1) to Run")
;re-use wheel colors as entry screen colors
Color wpcol(subtype,1)*0.5,wpcol(subtype,2)*0.5,wpcol(subtype,3)*0.5
Rect 210,370,270,80
Color 255,255,255
Rect 210,370,270,80,False
SetFont font3
Text 345-StringWidth(stage$(subtype))/2,375,stage$(subtype)
SetFont font1
Text 345-StringWidth(staged$(subtype))/2,420,staged$(subtype)
EndIf


If testing=1 Then toptext("Press Escape to Stop")
If testing=2 Then toptext("Stage Complete - Press Mouse (1) for Next")
If testing=3 Then toptext("Stage Failed - Press Mouse (1)")
EndIf


If levtype=3


Color 255,255,255
Rect 148,370,150,20

Color 128,0,128
Rect 147,369,152,22,False

Color 0,0,0
SetFont font1
Text 152,369,"Available panels"

SetFont font5

If testing=0 Then toptext("Press Mouse (1) to Run")
If testing=1 Then toptext("Running - Press Escape to Stop")
If testing=2 Then toptext("Puzzle Solved - Press Mouse (1) for Next")
If testing=3 Then toptext("Failed - Press Mouse (1) to Reset")


EndIf

EndIf


End Function



Function backstuff()

If levtype=3 And design=0
Color 255,255,128
Rect 150,370,400,100
EndIf

End Function


Function fixgener(gen.gener,xpos,ypos,facing)

;gen\ent=CopyEntity(genpoint)
PositionEntity gen\ent,xpos*4-22,0,24-ypos*4

full(xpos,ypos)=4+facing

If facing=1 Then rot=0
If facing=2 Then rot=180
If facing=3 Then rot=90
If facing=4 Then rot=270

RotateEntity gen\ent,0,rot,0

gen\x=xpos
gen\y=ypos
gen\face=facing
full(xpos,ypos)=4+facing

End Function


Function addcyl(wid#,hig#,col1,col2,col3,zpos#=0)

seg=CreateSphere(4,genpoint)
ScaleEntity seg,wid,0.1,wid
PositionEntity seg,0,hig,zpos
EntityColor seg,col1,col2,col3

Return(seg)

End Function

Function addarrow(who,dir,xpos,ypos)

;at this point arrows must be listed consecutively
;eg 1 or 1,2 or 1,2,3

If arwho(xpos,ypos)<>who Or optset(4)=0
If arwho(xpos,ypos)>0 Then Return(0)
EndIf

If arwho(xpos,ypos)=who
;in overwrite mode, delete overwritten arrow
For i=1 To totarrows(who)
If arin(who,i,1)=xpos And arin(who,i,2)=ypos
shiftarrows(who,i,totarrows(who))
totarrows(who)=totarrows(who)-1
Exit
EndIf
Next
EndIf



If full(xpos,ypos)>0 And full(xpos,ypos)<9 Then Return(0)
If full(xpos,ypos)=17 Then Return(0)

num=0
While num=0

If totarrows(who)<3
totarrows(who)=totarrows(who)+1
num=totarrows(who)
Exit
EndIf

;all spaces are full - so must shift along
shiftarrows(who,1,totarrows(who))
num=3 ;3 can now be overwritten

Wend



arwho(xpos,ypos)=who
ardir(xpos,ypos)=dir
arin(who,num,0)=2 ;exists
;note -cats can dent arrows, but need two hits
;use arin(-,-,0) to record this
arin(who,num,1)=xpos
arin(who,num,2)=ypos
arin(who,num,3)=dir
arin(who,num,4)=MilliSecs()+12000
arin(who,num,5)=1
rem_artime(who,num)=12000 ;for 'place arrows again'


posarrow(who,num,xpos,ypos,dir)

End Function


Function posarrow(who,num,xp,yp,com)

aent=narrow(who,num) ;when in game


PositionEntity aent,xp*4-22,0.1,24-yp*4
If arin(who,num,0)=2 Then ScaleEntity aent,1,1,1
If arin(who,num,0)=1 Then ScaleEntity aent,0.5,1,0.5

If com=1 Then rot=180
If com=2 Then rot=0
If com=3 Then rot=270
If com=4 Then rot=90

RotateEntity aent,0,rot,0
ShowEntity aent
calculate_normals(aent)

End Function


Function shiftarrows(who,fis,tot)

;arrow in slot one is the oldest (next to go)
;arrow in slot three is newest

;enter here if you place a new arrow
;or if a cat destroys an existing arrow

;if first arrow is destroyed - replace 1 with 2 and 2 with 3
;if second arrow is destroyed - replace 2 with 3
;if third arrow is destroyed - skip

arwho(arin(who,fis,1),arin(who,fis,2))=0
ardir(arin(who,fis,1),arin(who,fis,2))=0

If tot>=2 And fis=1
For pg=0 To 5
arin(who,1,pg)=arin(who,2,pg)
Next
posarrow(who,1,arin(who,1,1),arin(who,1,2),arin(who,1,3))
EndIf

If tot>=3 And fis<=2
For pg=0 To 5
arin(who,2,pg)=arin(who,3,pg)
Next
posarrow(who,2,arin(who,2,1),arin(who,2,2),arin(who,2,3))
EndIf

End Function


Function pointerstuff()

Local prx#,pry#,power=0

If levtype=1 And testing=1 Then power=1
If levtype=2 Then power=1
If levtype=3 And testing=0 Then power=1
If design=1 Then power=1

;for design only look at one
;for game will look at all (in versus mode)
loop=1
If design=0
If levtype=1 Or subtype>4 Then loop=4
EndIf


For va=1 To loop

If cplay(va)>=0

For j=1 To 8
ikey(j)=0
Next

If power=1
If cplay(va)=0 Or loop=1 Then humancon(va)
If cplay(va)>0 Then cpucon(va) ;can uncheck this for testing
EndIf


If contype=0 Or cplay(va)>0
If ikey(5)=1 Then pointpos(va,1)=pointpos(va,1)-0.2
If ikey(6)=1 Then pointpos(va,1)=pointpos(va,1)+0.2
If ikey(7)=1 Then pointpos(va,2)=pointpos(va,2)-0.2
If ikey(8)=1 Then pointpos(va,2)=pointpos(va,2)+0.2
EndIf

prx=pointpos(va,1)
pry=pointpos(va,2)
If prx<0.6 Then pointpos(va,1)=0.6:prx=0.6
If prx>12.4 Then pointpos(va,1)=12.4:prx=12.4
If pry<0.6 Then pointpos(va,2)=0.6:pry=0.6
If pry>9.3 Then pointpos(va,2)=9.3:pry=9.3

If va=1 Then projx=prx:projy=pry


For ii=1 To 4
PositionEntity bpoint(ii),pointpos(ii,1)*4-22,0,24-pointpos(ii,2)*4
Next

If design=0
For ii=1 To 4
If ikey(ii)=1
If levtype<3 And testing=1 Then addarrow(va,ii,Int(prx),Int(pry))
If levtype=3 And testing=0 Then addparrow(Int(prx),Int(pry),ii)
EndIf
Next
EndIf

EndIf

Next

End Function



Function mousestuff()

Local magnet,dturn=0,remain#=0
Local speed#=mouse_speed*factor

mwalk=mwalk+mwch*speed*50
If Abs(mwalk)>=mlimit And Sgn(mwalk*mwch)=1 Then mwch=-mwch

For m.mous=Each mous

omagnet=m\magnet

If event=5
m\magnet=1
If omagnet=0
m\xx=Rnd#(0.1)-0.05
m\yy=Rnd#(0.1)-0.05
EndIf
EndIf

If event<>5 And m\magnet=1 Then m\magnet=2

magnet=m\magnet

If m\adjust=1 Then adjust(m\ent,m\face)
m\adjust=0

RotateEntity m\piv1,mwalk,0,0
RotateEntity m\piv2,-mwalk,0,0



If m\dead=0 And m\magnet=0
m\x=m\x+adva(m\face,1)*speed
m\y=m\y+adva(m\face,2)*speed
If m\x<0.5 Then m\x=m\x+12
If m\x>12.5 Then m\x=m\x-12
If m\y<0.5 Then m\y=m\y+9
If m\y>9.5 Then m\y=m\y-9
EndIf


If m\dead=0 And m\magnet>0

mdist#=((m\x-basex)^2+(m\y-basey)^2)^0.5+1

If m\magnet=1 Then m\xx=(m\xx+(basex-m\x)/(mdist*100))*0.99
If m\magnet=1 Then m\yy=(m\yy+(basey-m\y)/(mdist*100))*0.99

If m\magnet=2 Then m\xx=m\xx*1.01
If m\magnet=2 Then m\yy=m\yy*1.01

m\x=m\x+m\xx
m\y=m\y+m\yy

If m\magnet=2
If m\x<-8 Or m\x>16 Or m\y<-3 Or m\y>15 Then m\dead=1
;off edge of screen
EndIf

EndIf



PositionEntity m\ent,(m\x)*4-22,1,24-(m\y)*4

rocket=0


If Abs(m\x-Int(m\x))<=speed*0.5 And Abs(m\y-Int(m\y))<=speed*0.5 And magnet=0
If Int(m\x)=m\nextx And Int(m\y)=m\nexty


rocket=mousecheck(m.mous)

If rocket=False ;mouse still exists
m\x=m\nextx
m\y=m\nexty
m\nextx=newx(m\x,m\face)
m\nexty=newy(m\y,m\face)

;m\x=m\x+adva(m\face,1)*remain
;m\y=m\y+adva(m\face,2)*remain


EndIf

EndIf
EndIf


If magnet>0
rocket=mousecheck(m.mous)
EndIf

If rocket=False

If m\dead=1
TurnEntity m\ent,0,15,0
m\faint=m\faint+0.02

EntityAlpha m\ent,1-m\faint

mp1=GetChild(m\ent,1)
mf1=GetChild(mp1,1)
EntityAlpha mf1,1-m\faint
mp2=GetChild(m\ent,2)
mf2=GetChild(mp2,1)
EntityAlpha mf2,1-m\faint

If m\faint>=0.99
mice=mice-1
If m\special>0
FreeEntity m\sptext
EndIf
FreeEntity m\ent
Delete m
EndIf
EndIf
EndIf

Next

End Function


Function mousecheck(m.mous)

Local mx=Int(m\x),my=Int(m\y)

If mx<1 Or mx>12 Or my<1 Or my>9 Then Return(0)

Local ful=full(mx,my)



If ful=17
m\dead=1
If modetype=2 And testing=1 Then showfail(m\x,m\y)
Return(0)
EndIf


will=1 ;set to zero to test mouse number limits

If ful>0 And ful<5 And will=1

db=ful
If teams=0 Then dbb=db
If teams=1 Then dbb=2-(db Mod 2) ;scoring combined in team mode

If m\special>0
FreeEntity m\sptext
EndIf

mice=mice-1
;in stage challenge and puzzle - task is complete when mice=0
;mice value will be set at the beginning based on full()

;note - only normal mice are present in stage challenge and puzzle
If m\special=0
If modetype=1 Then score(dbb)=score(dbb)+1
If score(dbb)>999 Then score(dbb)=999
sfxs(use)=PlaySound(squeak)
use=use+1
If use=101 Then use=1
EndIf

If m\special=1
score(dbb)=score(dbb)+50
If score(dbb)>999 Then score(dbb)=999
sfxs(use)=PlaySound(super50)
use=use+1
If use=101 Then use=1

pp.pic=New pic
pp\ent=CopyEntity(ups)
PositionEntity pp\ent,EntityX(bases(db)),1,EntityZ(bases(db))
pp\time=MilliSecs()+1000

EndIf

If m\special=2
evrnd=Int(Rnd#(100)+0.5)
event=1
eventgot=db
If evrnd>20 Then event=2
If evrnd>34 Then event=3
If evrnd>48 Then event=4
If evrnd>62 Then event=5
If evrnd>67 Then event=6
If evrnd>72 Then event=7
If evrnd>86 Then event=8

animcats(0)

ShowEntity wheel

rem_timers() ;need to pause while wheel comes up

wheelat=10
waccel=-5
wclunk=0
wheelrot=0
gotevent=ful ;1-4, who got the ? mouse
EndIf

If levtype=1 Or subtype>4 Then pulseon(db)=10

If levtype>1
For kk.pbase=Each pbase
If kk\x=mx And kk\y=my
kk\pulseon=10
EndIf
Next
EndIf

FreeEntity m\ent
Delete m
Return(1)

EndIf
;end of bases section

cface=newdir(mx,my,m\face)

If m\face<>cface And m\magnet=0 Then m\adjust=1
m\face=cface

End Function



Function catstuff()

Local magnet,dturn=0,remain#=0
Local speed#=cat_speed*factor


For c.catt=Each catt

magnet=c\magnet
If event<>6 Or c\magnet=1

If c\adjust=1 Then adjust(c\ent,c\face)
c\adjust=0


If c\dead=0 And c\magnet=0

;DebugLog(speed)

c\x=c\x+adva(c\face,1)*speed
c\y=c\y+adva(c\face,2)*speed
If c\x<0.5 Then c\x=c\x+12
If c\x>12.5 Then c\x=c\x-12
If c\y<0.5 Then c\y=c\y+9
If c\y>9.5 Then c\y=c\y-9
EndIf


If c\dead=0 And c\magnet=1

c\xx=(c\xx+(c\destx-c\x)/500)*0.99
c\yy=(c\yy+(c\desty-c\y)/500)*0.99

c\x=c\x+c\xx
c\y=c\y+c\yy

EndIf



PositionEntity c\ent,(c\x)*4-22,0,24-(c\y)*4

rocket=0


If Abs(c\x-Int(c\x))<=speed*0.5 And Abs(c\y-Int(c\y))<=speed*0.5 And magnet=0
If Int(c\x)=c\nextx And Int(c\y)=c\nexty


rocket=catcheck(c.catt)

If rocket=False ;cat still exists

;DebugLog(remain)

c\x=c\nextx
c\y=c\nexty
c\nextx=newx(c\x,c\face)
c\nexty=newy(c\y,c\face)

EndIf

EndIf
EndIf


If magnet=1
rocket=catcheck(c.catt)
EndIf

If rocket=False

If event=1 And wheelat<1 Then c\dead=1 ;cats die when mouse mania starts

If c\magnet=0

For ww.catt=Each catt
;stop cats bunching - if they get too close one dies

If ww\face=c\face And ww\dead=0

sqdist#=(c\x-ww\x)^2+(c\y-ww\y)^2
If sqdist#>0 And sqdist#<0.5

If ww\magnet=0 Then c\dead=1

EndIf
EndIf

Next

EndIf


If c\dead=1
TurnEntity c\ent,0,15,0
c\faint=c\faint+0.02

EntityAlpha c\anima,1-c\faint

If c\faint>=0.99
cats=cats-1
FreeEntity c\ent
Delete c
EndIf
EndIf
EndIf


EndIf

Next


For pz.parrow=Each parrow
;catch up with arrow destruction by cats

If pz\damg=1

pz\damg=0
pz\size=pz\size-1

If pz\size=1 Then ScaleEntity pz\ent,0.5,1,0.5
If pz\size=0

HideEntity pz\ent
ardir(pz\x,pz\y)=0

EndIf
EndIf

Next

End Function


Function catcheck(c.catt)

Local cx=Int(c\x),cy=Int(c\y)

If full(cx,cy)=17
If c\magnet=0 Or panning=1
;if panning=1 then bases act like holes
;prevents cat attacks from leaving the board
c\dead=1
If cats=1 And modetype=2 And testing=1 And subtype=3 Then showfail(c\x,c\y)
Return(0)
EndIf
EndIf



will=1 ;set to zero to test cat number limits

If full(cx,cy)>0 And full(cx,cy)<5 And will=1

db=full(cx,cy)
If teams=0 Then dbb=db
If teams=1 Then dbb=2-(db Mod 2)

If modetype=1
FreeEntity c\ent
Delete c

cats=cats-1
sfxs(use)=PlaySound(explode)
use=use+1
If use=101 Then use=1

If subtype<>5 Then score(dbb)=score(dbb)*2/3 ;normal rules
If subtype=5 Then score(dbb)=score(dbb)-1 ;cat soccer rules

pulseon(db)=10

pp.pic=New pic
pp\ent=CopyEntity(ouchs)
PositionEntity pp\ent,cx*4-22,1,24-cy*4
pp\time=MilliSecs()+1000
EndIf


If modetype=2 Then showfail(c\x,c\y)


Return(1)

EndIf



cface=newdir(cx,cy,c\face)


If levtype<3 And arhere=convert(c\face,2)
;cat damaging arrow

For i=1 To 4
For j=1 To totarrows(i)

If arin(i,j,1)=cx And arin(i,j,2)=cy
arin(i,j,0)=arin(i,j,0)-1
If arin(i,j,0)=1 Then ScaleEntity narrow(i,j),0.5,1,0.5
If arin(i,j,0)=0
shiftarrows(i,j,totarrows(i))
HideEntity narrow(i,totarrows(i))
totarrows(i)=totarrows(i)-1
i=4:j=3
EndIf
EndIf

Next
Next

EndIf


If levtype=3 And arhere=convert(c\face,2)


For pz.parrow = Each parrow

If pz\x=cx And pz\y=cy Then pz\damg=1
;delay arrow damage until all cats have been checked
Next

EndIf


If c\face<>cface And c\magnet=0 Then c\adjust=1
c\face=cface

End Function


Function newdir(px,py,of,carrow=0)

;change of direction of mice/cats
;in response to arrows/walls

;carrow>0 looks at what would happen if an arrow was there
;carrow=0 looks at what actually 'is' there

;note - if an arrow is here, the 'out' direction is always the same

Local nf

If carrow=0 Then arhere=ardir(px,py)
If carrow>0 Then arhere=carrow ;used for cpu AI
If arhere>0 Then of=arhere

nf=of

tries=0
While wall(px,py,nf)=1
;DebugLog(px+" "+py+" "+nf)
tries=tries+1
If tries=4 Then Return(-1) ;totally boxed in
nf=try(of,tries)
Wend

Return(nf)

End Function


Function generators()

If subtype=5 Then event=2 ;cat mania in cat soccer

If event=1 Then mrate=10 Else mrate=50
If event=5 Then mrate=20
crate=1500+cats*500
If event=2 Then crate=150

If event<>2 And mice<100
For ge.gener=Each gener
mousernd=Int(Rnd#(mrate)+0.5)
If mousernd=1 Then newmouse(ge\x,ge\y,ge\face,1)
Next
EndIf

If event<>1 And event<>5 And cats<5
For ge.gener=Each gener
catrnd=Int(Rnd#(crate)+0.5)
If catrnd=1 Then newcat(ge\x,ge\y,ge\face,0,1)
Next
EndIf

End Function

Function arrowstuff()

For dc=1 To 4

For ef=1 To totarrows(dc)

ntime=arin(dc,ef,4)-MilliSecs()
If ntime<2000
arin(dc,ef,5)=1-arin(dc,ef,5)
If arin(dc,ef,5)>0 Then ShowEntity narrow(dc,ef)
If arin(dc,ef,5)=0 Then HideEntity narrow(dc,ef)
EndIf

If ntime<0
shiftarrows(dc,1,totarrows(dc))
HideEntity narrow(dc,totarrows(dc))
totarrows(dc)=totarrows(dc)-1
EndIf

Next

Next

End Function


Function basepulse()

If levtype=1 Or subtype>4

For dc=1 To 4

If pulseon(dc)=0
If pulse(dc)>0 And pulse(dc)<180 Then pulse(dc)=pulse(dc)-15
If pulse(dc)>=180 Then pulse(dc)=pulse(dc)+15
EndIf

If pulseon(dc)>0
pulseon(dc)=pulseon(dc)-1
pulse(dc)=pulse(dc)+15
EndIf

If pulse(dc)>=360 Then pulse(dc)=pulse(dc)-360

pulses#=1.1+Sin(pulse(dc)-90)*0.1
ScaleEntity bases(dc),pulses,pulses,pulses
Next

EndIf

If levtype>1

For kk.pbase=Each pbase

If kk\pulseon=0
If kk\pulse>0 And kk\pulse<180 Then kk\pulse=kk\pulse-15
If kk\pulse>=180 Then kk\pulse=kk\pulse+15
EndIf

If kk\pulseon>0
kk\pulseon=kk\pulseon-1
kk\pulse=kk\pulse+15
EndIf

If kk\pulse>=360 Then kk\pulse=kk\pulse-360

pulses#=1.1+Sin(kk\pulse-90)*0.1
ScaleEntity kk\ent,pulses,pulses,pulses
Next

EndIf

End Function


Function newsurface(gpos)


nsurf=CreateSurface(grid)

For fb=-18 To 18 Step 4
For fa=-24 To 24 Step 4

AddVertex(nsurf,fa,0,fb)
cc=CountVertices(nsurf)


If fb>-18 And fa>-24
If (fa+fb+42) Mod 8=gpos
AddTriangle(nsurf,cc-2,cc-14,cc-15)
AddTriangle(nsurf,cc-2,cc-1,cc-14) 
EndIf
EndIf

Next
Next


Return(nsurf)

End Function


Function newsphere(which,bsurf,xpos#,ypos#,zpos#,xscal#,yscal#,zscal#,texon=1,aposy#=0)


Local vx#,vy#,vz#,dx#,dy#,dz#,magn#,bx#,by#

bx#=((texon-1) Mod 4)*0.25+0.12
by#=((texon-1)/4)*0.25+0.12

cc=CountVertices(bsurf)

For i=0 To CountVertices(suse)-1

vx=xpos+VertexX(suse,i)*xscal
vy=ypos+VertexY(suse,i)*yscal
vz=zpos+VertexZ(suse,i)*zscal

seen(i)=1
If vy<-aposy Then seen(i)=0

If start<19

For j=start To finish

If j<>which

dx=vx-spdet(j,1)
dy=vy-spdet(j,2)
dz=vz-spdet(j,3)
magn=(dx/spdet(j,4))^2+(dy/spdet(j,5))^2+(dz/spdet(j,6))^2
;DebugLog(magn)
If magn<1 Then seen(i)=0

EndIf

Next

EndIf

AddVertex bsurf,vx,vy,vz,bx,by

;VertexColor bsurf,i+cc,col1,col2,col3
Next

For i=0 To CountTriangles(suse)-1
t1=TriangleVertex(suse,i,0)
t2=TriangleVertex(suse,i,1)
t3=TriangleVertex(suse,i,2)

If seen(t1)+seen(t2)+seen(t3)>0
AddTriangle bsurf,t1+cc,t2+cc,t3+cc
EndIf
Next

End Function


Function leveldesign()

Local dkey=0
Local prx=Int(projx),pry=Int(projy)

;BrushColor brush(1),Rnd#(200),Rnd#(200),Rnd#(200)
;PaintSurface gsurf1,brush(1)

If KeyHit(46) ;C
clearboard() ;clear the map - ready to start creating a new one
newboard()
show()
EndIf


For mc=1 To 4
If KeyHit(ctrl(mc))
addobject(mc,1)
initlock=1
ilx=prx
ily=pry
EndIf

If KeyDown(ctrl(mc)) Then dkey=1

If lockout=0 And initlock=0
If KeyDown(ctrl(mc)) Then addobject(mc,0)
EndIf

Next

If prx<>ilx Or pry<>ily Then initlock=0



If KeyDown(211) Then addobject(0,-1) ;delete object

If dkey=0 Then lockout=0:delmode=1

If MouseHit(1)

If modetype=1


;can move generators and bases around
;there are always 4 of each in this mode


For kc=1 To 4
If prx=basepos(kc,1) And pry=basepos(kc,2) And drag=0
drag=1:dged=kc
remfull=full(prx,pry)
full(prx,pry)=0
EndIf
Next

gcount=0
For kd.gener=Each gener
gcount=gcount+1

If prx=kd\x And pry=kd\y And drag=0
drag=2
hcount=gcount
remfull=full(prx,pry)
full(prx,pry)=0
Exit
EndIf

Next

EndIf

If drag=0
;note - holes and walls still need to be accounted for in versus mode
Repeat
tileon=tileon+1
If tileon=7 Then tileon=1
Until topen(tileon)=1
EndIf


EndIf






If drag=2 Then caught.gener=Object.gener(hcount)

keepheld=0
If MouseDown(1) Then keepheld=1
If full(prx,pry)>0 Then keepheld=1

If keepheld=1
If drag=1
PositionEntity bases(dged),projx*4-22,0,24-projy*4
PositionEntity abase(dged),projx*4-22,aby,24-projy*4
EndIf
If drag=2
PositionEntity caught\ent,projx*4-22,0,24-projy*4
EndIf

EndIf



If keepheld=0
If drag=1
basepos(dged,1)=prx
basepos(dged,2)=pry
full(prx,pry)=remfull
PositionEntity bases(dged),basepos(dged,1)*4-22,0,24-basepos(dged,2)*4
PositionEntity abase(dged),basepos(dged,1)*4-22,aby,24-basepos(dged,2)*4
drag=0
EndIf

If drag=2
caught\x=prx
caught\y=pry
full(prx,pry)=remfull
PositionEntity caught\ent,caught\x*4-22,0,24-caught\y*4
drag=0
EndIf

EndIf



If MouseHit(2)

turngen=0

If modetype=1

If keepheld=1 And drag=2
;change generator direction while dragging
TurnEntity caught\ent,0,-90,0
turngen=1
caught\face=convert(caught\face,1)
remfull=4+caught\face

EndIf


For kd.gener=Each gener
If prx=kd\x And pry=kd\y And drag=0
TurnEntity kd\ent,0,-90,0
turngen=1
kd\face=convert(kd\face,1)
full(prx,pry)=4+kd\face
info=kd\face

EndIf
Next
EndIf

If turngen=0
Repeat
tileon=tileon-1
If tileon=0 Then tileon=6
Until topen(tileon)=1
EndIf

EndIf



End Function


Function leveltext()

;text stuff where design=1
Local prx=Int(projx),pry=Int(projy)

SetFont font1
Color 255,255,255


Text 20,100,"Contents = "+full(prx,pry)
Text 20,120,"Ardir = "+ardir(prx,pry)
If messtime>MilliSecs() Then Text 150,0,message$


For md=1 To 6
If topen(md)=1 Then Color 255,255,255
If topen(md)=0 Then Color 128,128,128
Text 20,130+md*20,tile$(md)
Next

Color 255,0,0

Rect 10,130+tileon*20,100,18,False


;Text 0,100,info
;Text 0,130,projx
;Text 0,160,projy
;Text 0,220,full(1,1)
;Text 0,250,remfull




If levtype=3
SetFont font5




If testing=0
Color 255,0,0
Text 150,400,"NOT TESTED"
Text 150,430,"Press Enter when ready to test"
EndIf

If testing=1
Color 128,128,255
Text 150,400,"TESTING"
Text 150,430,"Press Escape to Stop"
EndIf

If testing=2
Color 0,255,0
Text 150,400,"TESTED - VALID"
Text 150,430,"Press Enter to Save"
EndIf

If testing=3
Color 255,0,0
Text 150,400,"TESTED - INVALID"
Text 150,430,"Press Enter to Reset"
EndIf

;puzzlerun()

EndIf


End Function


Function convert(acface,trans)

c1=cpass(4+acface)
c1=c1+trans
If c1>4 Then c1=c1-4
If c1<1 Then c1=c1+4

Return(cpass(c1))

End Function

Function flipseg(fv,onoff,orient)
;fv=firstvert
Local xc#,zc#

For jn=0 To 3
xc=0:zc=0
If jn=0 Or jn=2 Then mdir=-1
If jn=1 Or jn=3 Then mdir=1
If orient=1 Then zc=mdir*wthic*2
If orient=2 Then xc=mdir*wthic*2
If onoff=0 Then xc=-xc:zc=-zc
VertexCoords wsurf,fv+jn,VertexX(wsurf,fv+jn)+xc,VertexY(wsurf,fv+jn),VertexZ(wsurf,fv+jn)+zc
Next
End Function


Function doublewall(xpos,ypos,rpos,onoff)


;If onoff=1 Then DebugLog(xpos+" "+ypos+" "+rpos+" "+onoff)

Local oside=0

nxpos=xpos+adva(rpos,1)
nypos=ypos+adva(rpos,2)
If rpos<3 Then nrpos=3-rpos
If rpos>2 Then nrpos=7-rpos

If nxpos=0 Then nxpos=12:oside=1
If nxpos=13 Then nxpos=1:oside=1
If nypos=0 Then nypos=9:oside=1
If nypos=10 Then nypos=1:oside=1

;DebugLog(nxpos+" "+nypos+" "+remwall(nxpos,nypos,nrpos)+" "+onoff)


If remwall(nxpos,nypos,nrpos)<>onoff

wall(nxpos,nypos,nrpos)=onoff
remwall(nxpos,nypos,nrpos)=onoff
;DebugLog(nxpos+" "+nypos+" "+nrpos+" "+onoff)
If oside=1 Then intoflip(nxpos,nypos,nrpos,onoff)
EndIf

End Function


Function intoflip(ppos,qpos,rdir,onoff)

If rdir=1 Then flipseg(468+(qpos-1)*48+(ppos-1)*4,onoff,1)
If rdir=2 Then flipseg(468+qpos*48+(ppos-1)*4,onoff,1)
If rdir=3 Then flipseg((ppos-1)*36+(qpos-1)*4,onoff,2)
If rdir=4 Then flipseg(ppos*36+(qpos-1)*4,onoff,2)

If onoff=1 Then calculate_normals(wallmesh)

End Function



Function savelevel()

If FileName$=""
init$=getfile$(levtype,0,0)
FileNumber = 0  
Repeat  FileNumber = FileNumber + 1  
FileName$ = init$ + display$(num)
Until Not(FileType(FileName$))  
EndIf

sev=WriteFile(FileName$)

WriteString sev,levname$

WriteInt sev,levtype

For fa=1 To 12
For fb=1 To 9
For fc=1 To 4
WriteInt sev,wall(fa,fb,fc)
Next
Next
Next

For fa=1 To 12
For fb=1 To 9
WriteInt sev,full(fa,fb)
Next
Next

If levtype=3
For pz.parrow=Each parrow
WriteInt sev,pz\x
WriteInt sev,pz\y
WriteInt sev,pz\face
Next
EndIf

CloseFile sev

message$="Saved ("+levname$+")"
messtime=MilliSecs()+2000

End Function



Function loadlevel(num)

FileName$=getfile$(levtype,num,puzd)

lod=ReadFile(FileName$)

If lod=0 Then levname$="New Level"
If lod=0 Then Return(0)

levname$=ReadString(lod)

levtype=ReadInt(lod)
;levtype=1 ;for mode testing

For fa=1 To 12
For fb=1 To 9
For fc=1 To 4
wall(fa,fb,fc)=ReadInt(lod)
Next
Next
Next

For fa=1 To 12
For fb=1 To 9
full(fa,fb)=ReadInt(lod)
If full(fa,fb)>17 Then full(fa,fb)=0
Next
Next

If levtype=3
While Not Eof(lod)
If KeyHit(1) Then End
pz.parrow=New parrow
pz\ent=CopyEntity(arrow(1))
pz\x=ReadInt(lod)
pz\y=ReadInt(lod)
pz\face=ReadInt(lod)
pz\used=0
pz\size=2
Wend
EndIf


CloseFile lod

End Function


Function setup()

;start with a completely empty board (no walls)
;and use the loaded info to build the level
;also reset variables

For i=1 To 4

If survival=1 And cplay(i)=-2 Then cplay(i)=oplay(i)

If levtype=1 And challenge=0 And survival=0 And watching=0
;set player types based on 'select players' screen
If plcho(i)=1 Then cplay(i)=0 ;human
If plcho(i)=2
If cpcho(i)<6 Then cplay(i)=cpcho(i) ;cpu
If cpcho(i)=6 Then cplay(i)=Int(Rnd#(5)+0.5)
EndIf
If plcho(i)=3 Then cplay(i)=-1 ;no player (base remains)
EndIf

HideEntity bcrown(i)
Next

If levtype>1 Then cplay(1)=0 ;player 1 must be human

If levtype=2 ;stage mode
cplay(2)=2:cplay(3)=2:cplay(4)=2 ;set cpu difficulty
EndIf

If survival=1 And challenge=0 ;survival mode
;cplay(1)=2
cplay(2)=2:cplay(3)=2:cplay(4)=2 ;set cpu difficulty
EndIf

If watching=1
cplay(1)=2:cplay(2)=2:cplay(3)=2:cplay(4)=2 ;watch mode
EndIf

foes=0
For k=2 To 4
If cplay(k)>0 Or cplay(k)=-2 Then foes=foes+1
Next


roundtime=2
gamespeed=3
eventrate=2

If levtype=1 And challenge=0
;options only effective in certain modes
roundtime=optset(1)
gamespeed=optset(2)
eventrate=optset(3)
EndIf


If ingame=1

mouse_speed=unit/(16-gamespeed*2)
cat_speed=mouse_speed*2/3

If levtype=1 And challenge=0
newsign(statex,2,1,-0.5,30)
EndIf


oscheme=scheme
Repeat
scheme=Int(Rnd#(4)+0.5)
Until scheme<>oscheme Or oscheme=0

For pp=1 To 2
osurf=GetSurface(grid,pp)
PaintSurface osurf,brush(scheme,pp)
Next

EndIf


stx=0:sty=0:stxx=0:styy=0
tux=0:tuy=180:tuxx=0:tuyy=0
tum=0:tumm=0

event=0:testing=0:factor=1
paused=0:panning=0:winner=0:cvictory=0
xwinner=0:winscreen=0

If levtype<3 Then EntityColor wallmesh,0,0,192
If levtype=3 Then EntityColor wallmesh,192,0,0



If levtype>1 And subtype<5

For pp=1 To 12
For qq=1 To 9

If full(pp,qq)=1
bb.pbase=New pbase
bb\ent=CopyEntity(bases(5))
bb\x=pp
bb\y=qq
PositionEntity bb\ent,pp*4-22,0,24-qq*4
calculate_normals(bb\ent)
EndIf

Next
Next
EndIf



For pp=1 To 12
For qq=1 To 9
For rr=1 To 4
ww=wall(pp,qq,rr)
If ww<>remwall(pp,qq,rr) Then intoflip(pp,qq,rr,ww) ;makes walls visible
doublewall(pp,qq,rr,ww) ;makes sure both sides of each wall are effective
ww=wall(pp,qq,rr)
remwall(pp,qq,rr)=ww

Next
Next
Next



gr.gener=First gener

For pp=1 To 12
For qq=1 To 9

fu=full(pp,qq)

If modetype=1


If fu>0 And fu<5
;get base positions based on full() info
basepos(fu,1)=pp
basepos(fu,2)=qq
If cplay(fu)=-3 Then full(pp,qq)=17 ;non-player
EndIf

If fu>4 And fu<9
fixgener(gr.gener,pp,qq,fu-4)
calculate_normals(gr\ent)
gr=After gr
EndIf

EndIf

If fu=17 Then newhole(pp,qq)

If levtype>1

If fu=1 And subtype<5 Then newpbase(pp,qq)
If fu>8 And fu<13 Then newmouse(pp,qq,fu-8)
If fu>12 And fu<17 Then newcat(pp,qq,fu-12)

EndIf

Next
Next



If levtype=1 Or subtype>4

For ff=1 To 4
PositionEntity bases(ff),basepos(ff,1)*4-22,0,24-basepos(ff,2)*4
PositionEntity abase(ff),basepos(ff,1)*4-22,aby,24-basepos(ff,2)*4
pointpos(ff,1)=basepos(ff,1)
pointpos(ff,2)=basepos(ff,2)
calculate_normals(bases(ff))
calculate_normals(abase(ff))
Next

;generators only appear in versus mode
For gc.gener=Each gener
PositionEntity gc\ent,gc\x*4-22,0,24-gc\y*4

Next

EndIf



If levtype=3 ;solutions (levtype=3)
For pz.parrow=Each parrow
If design=1 Then posparrow(pz\x,pz\y,pz\face,pz.parrow)
If design=0 Then posparrow(0,0,pz\face,pz.parrow)

;DebugLog("new parrow")
Next
EndIf



testing=0

reset_time()

If levtype=3 And design=0 Then pospanels()


For i=1 To 6
topen(i)=0
If i<3 Then topen(i)=1
If levtype=3 Then topen(i)=1
Next

If levtype=2
If subtype<4 Then topen(4)=1
If subtype>1 And subtype<4 Then topen(5)=1
If subtype<>3 And subtype<>5 Then topen(3)=1
EndIf

calculate_normals(grid)
calculate_normals(wallmesh)

For ff=1 To 4
calculate_normals(bpoint(ff))
If levtype>1 And subtype<>5
If ff>1 Then HideEntity bpoint(ff)
EndIf
Next

;reset game variables
For pl=1 To 4
pulse(pl)=0
pulseon(pl)=0
score(pl)=0; =500 ;set high for cat stop checking
;(if score=0 then stopping them isn't necessary)
arnew(pl,0)=0 ;clears suggested arrows from memory
If subtype=5 Then score(pl)=20 ;for cat soccer
If survival=1 Then score(pl)=50 ;survival mode
Next

If survival=1 Then score(1)=100

surtime=MilliSecs()
beaten=0


End Function


Function newboard()



;setup level type
If levtype=2 Then subtype=(boardnum Mod 5)
If subtype=0 Then subtype=5
If boardnum=25 Then subtype=6 ;the final stage

If levtype=2 And subtype<5 Then teams=0
If levtype=2 And subtype>4 Then teams=1
;DebugLog(subtype)

If levtype=1 Then modetype=1
If levtype=2 And subtype<4 Then modetype=2
If levtype=2 And subtype>3 Then modetype=1
If levtype=3 Then modetype=2
If levtype<>2 Then subtype=0



;empty the board (except for edge walls)

For ii=1 To 12
For jj=1 To 9
For kk=1 To 4
remwall(ii,jj,kk)=wall(ii,jj,kk)
wall(ii,jj,kk)=0
Next
Next
Next

For ii=1 To 12
wall(ii,1,1)=1
wall(ii,9,2)=1
Next

For jj=1 To 9
wall(1,jj,3)=1
wall(12,jj,4)=1
Next


For pp=1 To 12
For qq=1 To 9
For rr=1 To 4
ww=wall(pp,qq,rr)
If ww<>remwall(pp,qq,rr) Then intoflip(pp,qq,rr,ww) ;makes walls visible
doublewall(pp,qq,rr,ww) ;makes sure both sides of each wall are effective
remwall(pp,qq,rr)=ww
Next
Next
Next

For vv.dhole=Each dhole
FreeEntity vv\ent
Delete vv
Next

For mm=1 To 12
For nn=1 To 9
full(mm,nn)=0
Next
Next

gcount=0
For oo.gener=Each gener
gcount=gcount+1
If modetype=1 Then fixgener(oo.gener,initgen(gcount,1),initgen(gcount,2),initgen(gcount,3))
If modetype=2 Then HideEntity oo\ent
Next

For mm=1 To 4
basepos(mm,1)=initbase(mm,1)
basepos(mm,2)=initbase(mm,2)
If levtype=1 Or subtype>4 Then full(initbase(mm,1),initbase(mm,2))=mm
;If levtype>1
;HideEntity bases(mm)
;HideEntity abase(mm)
;EndIf
Next

End Function


Function Calculate_Normals(ThisMesh)

If ingame=0 Then Return(0)

;Normal calculation function by sswift
;For some reason UpdateNormals started
;causing the game to crash, despite the
;fact that it worked fine before, so I've
;decided to use this.


	; Loop through all surfaces of the mesh.
	Surfaces = CountSurfaces(ThisMesh)
	For LOOP_Surface = 1 To Surfaces
		Surface_Handle = GetSurface(ThisMesh, LOOP_Surface)
		; Reset the number of connected polygons for each vertex.
		For LoopV = 0 To 32767	
			Vertex_ConnectedTris(LoopV) = 0
		Next	
	
	;DebugLog("Surfaces = "+Surfaces)
	;Delay 1000
	
		; Loop through all triangles in this surface of the mesh.
		Tris = CountTriangles(Surface_Handle)
		For LOOP_Tris = 0 To Tris-1
			; Get the vertices that make up this triangle.
				Vertex_0 = TriangleVertex(Surface_Handle, LOOP_Tris, 0)
				Vertex_1 = TriangleVertex(Surface_Handle, LOOP_Tris, 1)
				Vertex_2 = TriangleVertex(Surface_Handle, LOOP_Tris, 2)
	
			; Adjust the number of triangles each vertex is connected to and
			; store this triangle in each vertex's list of triangles it is connected to.
				ConnectedTris = Vertex_ConnectedTris(Vertex_0)
				Vertex_TriList(Vertex_0, ConnectedTris) = LOOP_Tris
				Vertex_ConnectedTris(Vertex_0) = ConnectedTris + 1
				ConnectedTris = Vertex_ConnectedTris(Vertex_1)
				Vertex_TriList(Vertex_1, ConnectedTris) = LOOP_Tris
				Vertex_ConnectedTris(Vertex_1) = ConnectedTris + 1
				ConnectedTris = Vertex_ConnectedTris(Vertex_2)
				Vertex_TriList(Vertex_2, ConnectedTris) = LOOP_Tris
				Vertex_ConnectedTris(Vertex_2) = ConnectedTris + 1
			; Calculate the normal for this face.
				; Get the corners of this face:
				Ax# = VertexX#(Surface_Handle, Vertex_0)
				Ay# = VertexY#(Surface_Handle, Vertex_0)
				Az# = VertexZ#(Surface_Handle, Vertex_0)
				Bx# = VertexX#(Surface_Handle, Vertex_1)
				By# = VertexY#(Surface_Handle, Vertex_1)
				Bz# = VertexZ#(Surface_Handle, Vertex_1)
				Cx# = VertexX#(Surface_Handle, Vertex_2)
				Cy# = VertexY#(Surface_Handle, Vertex_2)
				Cz# = VertexZ#(Surface_Handle, Vertex_2)
				; Triangle 1
				; Get the vectors for two edges of the triangle.
				Px# = Ax#-Bx#
				Py# = Ay#-By#
				Pz# = Az#-Bz#
				Qx# = Bx#-Cx#
				Qy# = By#-Cy#
				Qz# = Bz#-Cz#
				; Compute their cross product.
				Nx# = Py#*Qz# - Pz#*Qy#
				Ny# = Pz#*Qx# - Px#*Qz#
				Nz# = Px#*Qy# - Py#*Qx#
				; Store the face normal.
				Face_NX#(LOOP_Tris) = Nx#
				Face_NY#(LOOP_Tris) = Ny#
				Face_NZ#(LOOP_Tris) = Nz#
		Next
		
		;DebugLog("Triangles = "+Tris)
		;Delay 1000
		
		; Now that all the face normals for this surface have been calculated, calculate the vertex normals.
		Vertices = CountVertices(Surface_Handle)
		For LOOP_Vertices = 0 To Vertices-1
			; Reset this normal.
			Nx# = 0
			Ny# = 0
			Nz# = 0
			; Add the normals of all polygons which are connected to this vertex.
			Polys = Vertex_ConnectedTris(LOOP_Vertices)
				
			For LOOP_Polys = 0 To Polys-1
				ThisPoly = Vertex_TriList(LOOP_Vertices, LOOP_Polys)
				Nx# = Nx# + Face_NX#(ThisPoly)
				Ny# = Ny# + Face_NY#(ThisPoly)
				Nz# = Nz# + Face_NZ#(ThisPoly)				
			Next	
				
			; Normalize the new vertex normal.
			; (Normalizing is scaling the vertex normal down so that it's length = 1)
				Nl# = Sqr(Nx#^2 + Ny#^2 + Nz#^2)
				; Avoid a divide by zero error if by some freak accident, the vectors add up to 0.
				If Nl# = 0 Then Nl# = 0.1
				Nx# = Nx# / Nl#
				Ny# = Ny# / Nl#
				Nz# = Nz# / Nl#
			; Set the vertex normal.
			
				VertexNormal Surface_Handle, LOOP_Vertices, Nx#, Ny#, Nz#
						
		Next
	Next
	
		;DebugLog("Verticles = "+Vertices)
		;Delay 1000
	
End Function


Function newhole(xpos,ypos)

full(xpos,ypos)=17
hh.dhole=New dhole
hh\ent=CopyEntity(hole)
hh\x=xpos
hh\y=ypos
PositionEntity hh\ent,hh\x*4-22,0.01,24-hh\y*4
calculate_normals(hh\ent)

End Function


Function simsurf(onto,size#)

AddVertex onto,-size,0,size,0,0
AddVertex onto,size,0,size,1,0
AddVertex onto,-size,0,-size,0,1
AddVertex onto,size,0,-size,1,1

AddTriangle onto,0,1,2
AddTriangle onto,2,1,3

End Function


Function simsurf2(onto,size#,tx#,ty#)

AddVertex onto,-size,0,size,tx,ty
AddVertex onto,size,0,size,tx,ty
AddVertex onto,-size,0,-size,tx,ty
AddVertex onto,size,0,-size,tx,ty

AddTriangle onto,0,1,2
AddTriangle onto,2,1,3

End Function



Function maskit(texture,ref)

SetBuffer TextureBuffer(texture)

LockBuffer GraphicsBuffer()

For xx=0 To TextureWidth(texture)-1
For yy=0 To TextureHeight(texture)-1

rst=ReadPixelFast(xx,yy)


;If ref=2 Then rst=rst+16777216

If ref=2 And xx=32 And yy=32 Then rstref=rst


;If xx=0 And yy=0 Then maskit=rst

uu=rst
;If ref=2 Then 
uu=uu+16777216
b=uu Mod 256
uu=uu/256
g=uu Mod 256
uu=uu/256
r=uu Mod 256

If ref=2 And xx=32 And yy=32 Then bbb=b:ggg=g:rrr=r

do_mask=0

If ref=1
If r>g+50 Or r>b+50 Then do_mask=1
EndIf

If ref=2
If r+g+b<100 Then do_mask=1
EndIf

If ref=3 And r+g+b=0 Then do_mask=1

If ref=4 And r>128 Then do_mask=1

;do_mask=1

If do_mask=1
WritePixelFast xx,yy,$00000000
Else
WritePixelFast xx,yy,rst
EndIf

Next
Next


UnlockBuffer GraphicsBuffer()

SetBuffer BackBuffer()

End Function


Function savescreenshot()   
iFileNumber% = 0  
Repeat  iFileNumber = iFileNumber + 1  
sFileName$ = "chuchushot" + String$("0", 3 - Len(Str$(iFileNumber))) + iFileNumber + ".jpg"  
Until Not(FileType(sFileName))   
SaveBuffer FrontBuffer(), sFileName   
End Function


Function eatmouse()

Local sqdist#

For m.mous=Each mous

For c.catt=Each catt

If c\dead=0

sqdist=(m\x-c\x)^2+(m\y-c\y)^2

If sqdist<0.1
m\dead=1
If testing=1
If levtype=3 Or subtype=1 Or subtype=2
showfail(c\x,c\y)
EndIf
EndIf
Exit
EndIf

EndIf

Next
Next

End Function


Function picstuff()

Local ppt#,msize#

For pp.pic=Each pic

ppt=pp\time-MilliSecs()

msize=0.8+Sin#(ppt*0.36-90)*0.5
ScaleSprite pp\ent,6*msize,4*msize

If ppt<0
FreeEntity pp\ent
Delete pp
EndIf
Next

End Function


Function dowheel()

Local evsh=event-2
If evsh<1 Then evsh=evsh+8

wheelrot=wheelrot+waccel
If wheelrot<-90 Then wheelrot=wheelrot+360

RotateEntity wheel,wheelrot,0,0
PositionEntity wheel,0,(35-wheelat)/5,35-wheelat

;PositionEntity light3,0,EntityY(wheel),EntityZ(wheel)-5
;PointEntity light3,wheel


If wheelat<28 Then wheelat=wheelat+0.5
If wheelat>=28 And Abs(evsh*45-112-wheelrot)<3 And waccel<>0
RotateEntity wheel,wheelrot,0,0
waccel=0
wontime=MilliSecs()+1000
EndIf

If waccel<>0
wclunk=wclunk+1
If wclunk=9
wclunk=0
sfxs(use)=PlaySound(clunk)
use=use+1
If use=101 Then use=1

EndIf

EndIf

If waccel=0 And wontime<MilliSecs()
extime=0
If event<>3 And event<>4 And event<>6 Then animcats(1)
event_setup()
EndIf



End Function


Function event_setup()

Local extime#

If event=1 Or event=2 Then extime=10
If event=7 Or event=8 Then extime=8
If event=5 Then extime=6
If event=3 Then extime=3
If event=4 Or event=6 Then extime=1.5

wontime=MilliSecs()+extime*1000
wheelat=0
HideEntity wheel

If event=3 Then cleararrows()

If event=6 ;cat attack


tbase=0
For ge.gener=Each gener

tbase=tbase+1

If tbase<>eventgot And cplay(tbase)>-3
newcat(ge\x,ge\y,ge\face,tbase)
EndIf

Next


EndIf

If event=5 Then basex=basepos(eventgot,1):basey=basepos(eventgot,2)

For m.mous=Each mous
If m\special=2
FreeEntity m\sptext
m\special=0
EndIf
Next

If event=4

;choose random base swaps for 'everybody move'

eswap=Int(Rnd#(9)+0.5)

For i=1 To 4
isplace(i)=emoves(eswap,i)
Next

;DebugLog(isplace(1)+" "+isplace(2)+" "+isplace(3)+" "+isplace(4))

EndIf

End Function




Function eventend()

;route exchanging (for cpu update) is done with troute()
;more lines but quicker than calling f_route() again

If event=4
;finalise positions for everybody move

For i=1 To 4
temp(i,1)=basepos(isplace(i),1)
temp(i,2)=basepos(isplace(i),2)

For ii=1 To 12
For jj=1 To 9
troute(i,ii,jj)=route(isplace(i),ii,jj)
Next
Next

Next

For j=1 To 4
basepos(j,1)=temp(j,1)
basepos(j,2)=temp(j,2)
PositionEntity bases(j),basepos(j,1)*4-22,0,24-basepos(j,2)*4

full(temp(j,1),temp(j,2))=j
If cplay(j)=-3 Then full(temp(j,1),temp(j,2))=17 ;for challenge mode

For ii=1 To 12
For jj=1 To 9
route(j,ii,jj)=troute(j,ii,jj)
Next
Next

Next


EndIf

animcats(1)

event=0

End Function


Function addobject(dir,ref)

Local x=Int(projx),y=Int(projy),clear=0,fmake=0

;DebugLog(x+" "+y+" "+ref)

If tileon>1 And full(x,y)>4 And full(x,y)<9 Then Return(0)
If tileon>1 And levtype=1 And full(x,y)>0 And full(x,y)<5 Then Return(0)

If tileon=1 And ref=1 Then delmode=wall(x,y,dir)+1
If tileon=2 Then fmake=17
If tileon=3 Then fmake=1
If tileon=4 Then fmake=8
If tileon=5 Then fmake=12
If tileon=6 Then fmake=17
If tileon>3 Then fmake=fmake+dir

If tileon>1 And ref=1
delmode=1
If fmake=full(x,y) Then delmode=2
EndIf


If ref=0
If tileon>1
If full(x,y)=fmake And delmode=1 Then Return(0)
If full(x,y)<>fmake And delmode=2 Then Return(0)
EndIf
If tileon=1
If wall(x,y,dir)>0 And delmode=1 Then Return(0)
If wall(x,y,dir)=0 And delmode=2 Then Return(0)
EndIf
EndIf

If ref=-1 And full(x,y)=0 Then Return(0)
If ref=-1 Then fmake=full(x,y)

;If ref=0 Then DebugLog("aha")
;If ref=-1 Then DebugLog("wipe")

If fmake=full(x,y) Then clear=1 Else clear=0
If fmake>17 And ardir(x,y)=fmake-17 Then clear=1

;if fmake is the same as full(x,y), clear the square completely
;if different, clear it and then replace it

If tileon>1 And tileon<6 And full(x,y)>0 Then clearsquare(x,y,tileon)
If tileon=6 And ardir(x,y)>0 Then clearsquare(x,y,tileon)

If tileon=1 ;add or delete walls

newit=1
wallon=wall(x,y,dir)

;DebugLog(wallon)
wall(x,y,dir)=1-wallon
remwall(x,y,dir)=1-wallon

intoflip(x,y,dir,1-wallon)
doublewall(x,y,dir,1-wallon)
EndIf


If clear=0

If tileon=2 Then newhole(x,y)
If tileon=3 Then newpbase(x,y)
If tileon=4 Then newmouse(x,y,dir)
If tileon=5 Then newcat(x,y,dir)
If tileon=6 Then newparrow(x,y,dir)

EndIf


;If ref=1 Then DebugLog(delmode+" "+clear+" "+wall(x,y,dir))

If tileon>1 And delmode=1 And clear=1 Then lockout=1
If tileon>1 And delmode=2 And clear=0 Then lockout=1
If tileon=1 And delmode=1 And wall(x,y,dir)=0 Then lockout=1
If tileon=1 And delmode=2 And wall(x,y,dir)=1 Then lockout=1

If tileon>1 And tileon<6 And clear=1 Then full(x,y)=0
If tileon=6 And clear=1 Then ardir(x,y)=0
;DebugLog(wall(1,5,3)+" "+wall(12,5,4))

End Function




Function clearsquare(x,y,tileon)

If tileon<6

If full(x,y)=17 ;holes
For ii.dhole=Each dhole
If ii\x=x And ii\y=y
FreeEntity ii\ent
Delete ii
EndIf
Next
EndIf

If levtype=1 Then Return(0)

If full(x,y)=1 ;bases
For jj.pbase=Each pbase
If jj\x=x And jj\y=y
FreeEntity jj\ent
Delete jj
EndIf
Next
EndIf


If full(x,y)>8 And full(x,y)<13 ;mice
For m.mous=Each mous
If m\x=x And m\y=y
mice=mice-1
FreeEntity m\ent
Delete m
EndIf
Next
EndIf


If full(x,y)>12 And full(x,y)<17 ;cats
For c.catt=Each catt
If c\x=x And c\y=y
cats=cats-1
FreeEntity c\ent
Delete c
EndIf
Next
EndIf

EndIf



If tileon=6 ;arrows
For pz.parrow=Each parrow
If pz\x=x And pz\y=y
FreeEntity pz\ent
Delete pz
EndIf
Next
EndIf

End Function


Function adjust(animal,face)

If face=1 Then RotateEntity animal,0,180,0
If face=2 Then RotateEntity animal,0,0,0
If face=3 Then RotateEntity animal,0,270,0
If face=4 Then RotateEntity animal,0,90,0

End Function


Function newparrow(x,y,dir)

;DebugLog("new parrow")
;full(x,y)=17+dir
pz.parrow=New parrow
pz\ent=CopyEntity(arrow(1))
pz\x=x
pz\y=y
pz\face=dir
ardir(x,y)=dir
pz\used=0
pz\size=2 ;can be destroyed by cats
posparrow(x,y,dir,pz.parrow)

End Function


Function newpbase(xpos,ypos)
full(xpos,ypos)=1
pb.pbase=New pbase
pb\ent=CopyEntity(bases(5))
pb\x=xpos
pb\y=ypos
PositionEntity pb\ent,pb\x*4-22,0.01,24-pb\y*4
calculate_normals(pb\ent)
End Function


Function titles()

Local refresh=0 ;for map
If dorefresh=1 Then dorefresh=0:refresh=1

If KeyHit(1)

If tpage=1
saverecords()
save_opts()
End
EndIf
If tpage=3 Or tpage=4 Then tpage=1
If tpage=2
clearboard()
If levtype=1 Then tpage=3
If levtype>1 Or design=1 Or survival=1 Then tpage=1
EndIf

If tpage=1 Then watchtimer=MilliSecs()

EndIf


Color 64,64,255
Rect 0,0,640,480

Color 255,255,255
For i=40 To 580 Step 60
Rect i,0,2,480
Next
For i=40 To 440 Step 40
Rect 0,i,640,2
Next



If tpage=1

SetFont font6

For i=40 To 340 Step 300
For j=80 To 400 Step 80
Color 0,0,128
Rect i+2,j+2,238,38
Rect i+2,j+2,238,38
Color 255,255,255
If i=40 And j=80 And chalev=chalevs+1 Then Color 128,128,128

mode$=modename$((j-80)/80,(i+260)/300)
Text i+120-StringWidth(mode$)/2,j+2,mode$
Next
Next


Color 255,0,0
Rect design*300+42,levtype*80+82,238,38,False
Rect design*300+41,levtype*80+81,240,40,False
Rect design*300+40,levtype*80+80,242,42,False

teams=0:survival=0:challenge=0
fixwait=0:watching=0
If KeyHit(203) Or KeyHit(205) Then design=1-design:fixwait=1
If KeyHit(200) Then levtype=levtype-1:fixwait=1
If KeyHit(208) Then levtype=levtype+1:fixwait=1
If fixwait=1 Then watchtimer=MilliSecs()

If MilliSecs()-watchtimer>10000
watching=1 ;enter watch mode
showesc=1:escount=0
levtype=1:ingame=1:refresh=1
EndIf

If levtype=-1 Then levtype=4
If levtype=5 Then levtype=0
If KeyHit(28)
mode_t$=modename$(levtype,design+1)

If levtype=4 And design=0 Then levtype=1:teams=1
If levtype=4 And design=1 Then levtype=1:survival=1:design=0

If levtype=1 Then tpage=3 ;'select players' screen
If levtype>1 Or design=1 Or survival=1 Then tpage=2 ;go straight to stage select

If levtype=0 And design=1 Then tpage=4 ;options
If levtype=0 And design=0

If chalev=chalevs+1 Then PlaySound error

If chalev<chalevs+1
levtype=1:challenge=1
ingame=1:refresh=1 ;go immediately to game
getchal()
EndIf

EndIf

EndIf


If tpage=2 Then checkexists()
If tpage=2 Then refresh=1

EndIf


If tpage=4
Color 0,0,0
For i=0 To 320 Step 80
Rect 0,42+i,640,38
Next

Color 255,255,255
SetFont font6

Text 10,43,"OPTIONS (VERSUS MODES)"
For i=1 To 4
Color 255,255,255
If opton=i Then Color 255,0,0
Text 10,43+i*80,option$(i)
Next

Color 255,255,255
Text 450,123,optset(1)
Text 450,203,optset(2)
Text 450,283,qrate$(optset(3))
If optset(4)=0 Then Text 450,363,"No"
If optset(4)=1 Then Text 450,363,"Yes"

If KeyHit(200) And opton>1 Then opton=opton-1
If KeyHit(208) And opton<4 Then opton=opton+1
hitl=0:hitr=0
If KeyHit(203) Then hitl=1
If KeyHit(205) Then hitr=1

If opton=1 Then ll=1:rr=3
If opton=2 Then ll=1:rr=5
If opton=3 Then ll=0:rr=4
If opton=4 Then ll=0:rr=1
If hitl=1 And optset(opton)>ll Then optset(opton)=optset(opton)-1
If hitr=1 And optset(opton)<rr Then optset(opton)=optset(opton)+1

EndIf


If tpage=3

Color 0,0,0
Rect 0,42,640,38

Color 255,255,255
SetFont font6

Text 50,43,mode_t$
Text 300,43,"SELECT PLAYERS"

olook=plook
If KeyHit(203) Then plook=plook-1
If KeyHit(205) Then plook=plook+1
If plook=0 Then plook=4
If plook=5 Then plook=1
If KeyHit(200) And plcho(plook)>1 Then plcho(plook)=plcho(plook)-1
If KeyHit(208) And plcho(plook)<3 Then plcho(plook)=plcho(plook)+1

If plook<>olook
FlushKeys()
EndIf

If plook=1 And plcho(plook)=2
plcho(plook)=1 ;restrict to human
PlaySound error
EndIf

If plook>1 And plcho(plook)=1
plcho(plook)=2 ;restrict to non-human
PlaySound error
EndIf

If plcho(plook)=2
For k=1 To 6
If KeyHit(k+1) Then cpcho(plook)=k
Next
EndIf

Color 0,0,0
Rect 222,402,238,38

Color 255,255,255
SetFont font1

If plcho(plook)=1
Text 224,402,"Player 1 must be human and the"
Text 224,420,"others must be non-human"
EndIf

If plcho(plook)=2
Text 224,402,"Use number keys (1-6) to select"
Text 224,420,"different types of CPU opponent"
EndIf

If plcho(plook)=3
Text 224,402,"This option means that Player "+plook
Text 224,420,"will not take part in this game"
EndIf

For i=1 To 4
Color basecol(i,1),basecol(i,2),basecol(i,3)
Rect i*120-18,122,118,238

Color 0,0,0
Rect i*120-9,130,100,50
Rect i*120-9,205,100,140

Color 255,255,255
If plook=i Then Color 255,0,0
SetFont font5
Text i*120,135,"PLAYER"
Text i*120+38,155,i

;SetFont font1
For j=1 To 3
Color 255,255,255
If plcho(i)=j Then Color 255,0,0
Text i*120,185+j*30,pltype$(j)
Next

If plcho(i)=2
SetFont font4
Color 128,255,128
Text i*120,305,cputype$(cpcho(i))
SetFont font5
EndIf


Next


If KeyHit(28)
tpage=2
checkexists()
refresh=1
EndIf

EndIf


.stage_screen
If tpage=2

Color 0,0,0
Rect 342,242,300,240

Color 0,0,192

For i=40 To 280 Step 60
For j=80 To 240 Step 40

Rect i+4,j+4,55,35

Next
Next


Color 0,0,0
Rect 0,42,640,38

If design=0
;can press c to toggle normal/custom
Rect 42,322,298,38
Rect 42,362,298,38
SetFont font1
Color 255,255,255


If levtype=1 And survival=0
Text 50,325,tot_rounds+" round match"
Text 50,340,"Use number keys (1-5) to change this"
For i=1 To 5
If KeyHit(i+1) Then tot_rounds=i
Next
EndIf



If custom=0 And randomstage=0

If levtype=1 And survival=1

SetFont font7
Text 50,325,"Survival Record"

SetFont font6
snum=survrec(chy*5+chx-5)
textscore(snum,310,324,20,0)

EndIf

If levtype=2
SetFont font7
Text 50,325,"Best Time"
Text 270,325,clocker$(stagerec(chy*5+chx-5))
EndIf

If levtype=3
SetFont font7
Text 50,325,pdiff$(puzd)
SetFont font1
Text 175,325,"Press (1-4) to choose"
Text 175,340,"a section of puzzles"
EndIf

EndIf


If levtype>1 Or survival=1

If custom=1
SetFont font7
Text 50,325,"Custom Levels"
EndIf

If randomstage=1
SetFont font7
Text 50,325,"Random Stage"
EndIf

EndIf



SetFont font1
Text 50,365,"Press C to switch between"
Text 50,380,"standard and custom boards"

If KeyHit(46)
custom=1-custom:refresh=1
checkexists()
EndIf
EndIf





SetFont font7

If levtype=1 And custom=0 Then exists(25)=1 ;random stage

For i=1 To 5
For j=1 To 5

If exists(j*5+i-5)=0 Then Color 128,128,128
If exists(j*5+i-5)=1 Then Color 255,255,255

num$=Str$(j*5+i-5)
If levtype=1 And custom=0 And i=5 And j=5 Then num$="?"

Text i*60+9-StringWidth(num$)/2,j*40+45,num$

If levtype=3 And design=0 And custom=0 And passed(puzd*25+j*5+i-30)=1
DrawImage tick,i*60,j*40+35
EndIf

If levtype=2 And design=0 And custom=0 And passed(95+j*5+i)=1
DrawImage tick,i*60,j*40+35
EndIf

Next
Next

Color 255,255,255

SetFont font1
Text 490-StringWidth(levname$)/2,460,levname$

SetFont font6
mode$=mode_t$
Text 340-StringWidth(mode$)/2,43,mode$

If levtype=3 And custom=0

opuzd=puzd
If KeyHit(2) Then puzd=1:refresh=1
If KeyHit(3) Then puzd=2:refresh=1
If KeyHit(4) Then puzd=3:refresh=1
If KeyHit(5) Then puzd=4:refresh=1
If puzd<>opuzd Then checkexists()

EndIf

Color 255,0,0

Rect chx*60-18,chy*40+43,58,36,False
Rect chx*60-19,chy*40+42,60,38,False

If KeyHit(203) Then chx=chx-1:refresh=1
If KeyHit(205) Then chx=chx+1:refresh=1
If KeyHit(200) Then chy=chy-1:refresh=1
If KeyHit(208) Then chy=chy+1:refresh=1
If chx=0 Then chx=5
If chx=6 Then chx=1
If chy=0 Then chy=5
If chy=6 Then chy=1

If KeyHit(28)

yes=0
If design=1 Or exists(chy*5+chx-5)=1 Then yes=1
If yes=0 Then PlaySound error

If yes=1
;f_route()
ingame=1
refresh=1
EndIf
EndIf

EndIf

If refresh=1

.refresh
If watching=1 Then boardnum=Int(Rnd#(24)+0.5)

If challenge=0 And watching=0 Then boardnum=chy*5+chx-5
randomstage=0
If levtype=1 And custom=0 And boardnum=25
randomstage=1
boardnum=Int(Rnd#(24)+0.5)
EndIf

initialise()
reset_camera()
EndIf

update_camera()

UpdateWorld()
RenderWorld()

If tpage=2 And levtype=1 And randomstage=1
;keep the random stage a mystery
Color 0,0,128
Rect 342,242,300,240
Color 255,255,0
SetFont font7
For i=350 To 620 Step 30
For j=240 To 450 Step 30
Text i,j,"?"
Next
Next
EndIf

End Function


Function clearboard()

;clears everything
;hides board itself
;(used when returning to titles)

If xwinner=0 Then HideEntity space
If xwinner>0 Then winscreen=1
HideEntity ssign
HideEntity wheel
wheelat=0

For i=1 To 2
osurf=GetSurface(grid,i)
PaintSurface osurf,brush(1,i)
Next


For i=1 To 12
For j=1 To 9
full(i,j)=0
arwho(i,j)=0
ardir(i,j)=0
Next
Next

For at.atomex=Each atomex
FreeEntity at\ent
Delete at
Next

For m.mous=Each mous
FreeEntity m\ent
Delete m
Next
mice=0

For c.catt=Each catt
FreeEntity c\ent
Delete c
Next
cats=0

For ii.dhole=Each dhole
FreeEntity ii\ent
Delete ii
Next

For jj.pbase=Each pbase
FreeEntity jj\ent
Delete jj
Next

For pz.parrow=Each parrow
FreeEntity pz\ent
Delete pz
Next

For pp.pic=Each pic
FreeEntity pp\ent
Delete pp
Next

For gb=1 To 4
HideEntity bases(gb)
HideEntity bpoint(gb)
HideEntity abase(gb)
HideEntity bcrown(gb)
Next

For gr.gener=Each gener
HideEntity gr\ent
Next

HideEntity grid
HideEntity wallmesh
HideEntity ovpoint


cleararrows()

End Function


Function show()

Local bx1#,by1#,bx2#,by2#

ShowEntity grid
ShowEntity wallmesh

If levtype=1 Then points=4 Else points=1

If ingame=1
For ka=1 To 4
If cplay(ka)>=0
If ka=1 Then ShowEntity bpoint(ka)
If design=0
If levtype=1 Or subtype>4 Then ShowEntity bpoint(ka)
EndIf
EndIf
Next
EndIf

If teams<>basemode
;swap between individual bases and team bases
;by re-coloring parts of them


For gb=1 To 4

If teams=1
gbb=gb+2
If gbb>4 Then gbb=gbb-4
bx1=((gbb*2) Mod 4)*0.25+0.12
by1=((gbb*2)/4)*0.25+0.12
bx2=((gbb*2+1) Mod 4)*0.25+0.12
by2=((gbb*2+1)/4)*0.25+0.12
EndIf

If teams=0
bx1=((gb*2) Mod 4)*0.25+0.12
by1=((gb*2)/4)*0.25+0.12
bx2=((gb*2+1) Mod 4)*0.25+0.12
by2=((gb*2+1)/4)*0.25+0.12
EndIf


;basesurf(gb)=GetSurface(bases(gb),1)
For i=0 To CountVertices(basesurf(gb))-1
If VertexZ(basesurf(gb),i)>0
If i<baseverts Then VertexTexCoords basesurf(gb),i,bx1,by1
If i>=baseverts Then VertexTexCoords basesurf(gb),i,bx2,by2
EndIf
Next

Next

basemode=teams

EndIf


If levtype=1 Or subtype>4

For gb=1 To 4
;show all bases (even non-playing ones)
If cplay(gb)>-3
ShowEntity bases(gb)
EndIf
ShowEntity abase(gb)
Next
EndIf



If modetype=1
For gr.gener=Each gener
ShowEntity gr\ent
Next
EndIf

If ingame=1
ShowEntity space
If levtype=1 Or subtype=6 Then calculate_normals(wheel)
If levtype=1 And design=0
If challenge=0 Then ShowEntity ssign
signz=30
EndIf
EndIf


End Function

Function checkexists()

For num=1 To 25
init$=getfile$(levtype,num,puzd)
exists(num)=FileType(init$)
Next

End Function


Function display$(num)
If num=0 Then Return("")
Return(String$("0", 2 - Len(Str$(num))) + num)
End Function


Function getfile$(levtype,num,puzd)

klet$=Lower$(Left$(pdiff$(puzd),1))
If design=1 And editmode=0 Then custom=0
If design=1 And editmode=1 Then custom=1

If custom=0 Then init$="chulevels/levels/"
If custom=1 Then init$="chulevels/custom/"

If levtype=1 Then init$=init$+"versus/"
If levtype=2 Then init$=init$+"stage/"
If levtype=3 And custom=0 Then init$=init$+"puzzle-"+klet$+"/"
If levtype=3 And custom=1 Then init$=init$+"puzzle/"

Return(init$+display$(num))

End Function


Function pospanels()

;levtype=3 ;design=0
;position all the available panels in the yellow box
Local posx=2,posy=11

For dd=1 To 4
For pz.parrow=Each parrow

;DebugLog(dd+" "+pz\face+" "+pz\used)

If pz\face=dd And pz\used=0

posparrow(posx,posy,dd,pz.parrow)
posx=posx+1

EndIf

Next
Next

End Function


Function addparrow(xpos,ypos,dir)

;puzzle arrow function

Local avail=0

For pz.parrow=Each parrow

If pz\x=xpos And pz\y=ypos

avail=1
If pz\face=dir Then avail=-1 ;just removing an arrow
pz\used=0
full(xpos,ypos)=0
ardir(xpos,ypos)=0 ;stop arrow having any effect

EndIf

Next


If avail>=0

For pz.parrow=Each parrow

If pz\face=dir And pz\used=0
avail=1
pz\used=1
posparrow(xpos,ypos,dir,pz.parrow)
Exit
EndIf

Next

EndIf


If avail=0 Then PlaySound error
If avail<>0 Then pospanels() ;reposition the available panels

End Function


Function posparrow(xp,yp,com,pz.parrow)

If xp>0
pz\x=xp
pz\y=yp
pz\face=com
PositionEntity pz\ent,xp*4-22,0.1,24-yp*4

If yp<10
ardir(xp,yp)=com
EndIf
EndIf

If com=1 Then rot=180
If com=2 Then rot=0
If com=3 Then rot=270
If com=4 Then rot=90

RotateEntity pz\ent,0,rot,0
If ingame=0 And design=0 Then HideEntity pz\ent
If ingame=1 Or design=1 Then ShowEntity pz\ent


calculate_normals(pz\ent)

End Function



Function maincontrol()

Local otest=testing

Color 255,255,255

If testing=1 And levtype>1 And design=1
;if design=0 this is handles by pause menu
If KeyHit(1)
puzreset()
Return(0)
EndIf
EndIf

goahead=0
If trigger=1 Then goahead=1:trigger=0

If design=0
If levtype>1 Or challenge-testing=1 Or cvictory<>0
If MouseHit(1) Then goahead=1
EndIf
If levtype=1 And testing=0
If design=0 And signz<-1 Then goahead=1
If design=1 Then goahead=1
EndIf


EndIf


If design=1
If KeyHit(28) Then goahead=1
If KeyHit(1)
backtomenu()
Return(0)
EndIf
EndIf






If goahead=1

If challenge=1 And testing=0 Then signz=-2 ;makes sure signs function


If challenge=1 And cvictory<>0

If cvictory=1 Then chalev=chalev+1
StopChannel musc

If chalev=chalevs+1
backtomenu()
Return(0)
EndIf

getchal()
initialise()
reset_camera()
signz=30 ;stops next level from starting immediately
Return(0)



EndIf




;as they do in normal versus matches

cansave=0
If levtype<3 Or testing=2 Then cansave=1
If design=0 Then cansave=0

If testing=1 And levtype=3
rapid=1-rapid ;accelerate/de-accelerate time
EndIf


If design=0 Or levtype=3

If testing=0

If design=1 ;puzbug
;testing=2 ;allow part-completed puzzles to be saved
;Return(0) ;delete these lines later
EndIf

testing=1
rapid=0
If design=1 And mice=0
testing=3
Return(0)
EndIf
FlushKeys()
EndIf
EndIf


If cansave=1

SetBuffer FrontBuffer()
FlushKeys()

SetFont font1
newname$=Input$("Level Name :")
If newname$<>"" Then levname$=newname$

savelevel()

FlushKeys()
SetBuffer BackBuffer()

EndIf

If testing=3 Then reset_time()
If testing=3 Then puzreset()
If testing=2 And design=1 Then puzreset()

If testing=2 And design=0;puzbug
;DebugLog(boardnum)
boardnum=boardnum+1
If randomstage=1 Then boardnum=Int(Rnd#(24)+0.5)
finished=0

If levtype=1 And boardnum=25 Then boardnum=1
If levtype=2 And boardnum=26 Then finished=1
If levtype=3 And boardnum=26 Then boardnum=1:puzd=puzd+1
If levtype=3 And puzd=5 Then puzd=4:finished=1
If exists(boardnum)=0 Then finished=1

If finished=0 Then initialise()
If finished=1 Then backtomenu()
EndIf

EndIf




If otest=0 And testing=1

animcats(1)

;adjust directions immediately based on walls/arrows
For m.mous=Each mous
initmouse(m.mous)
Next
For c.catt=Each catt
initcat(c.catt)
Next
EndIf

End Function


Function puzreset()

For m.mous=Each mous
FreeEntity m\ent
Delete m
Next
mice=0

For c.catt=Each catt
FreeEntity c\ent
Delete c
Next
cats=0

For zz.pic=Each pic
FreeEntity zz\ent
Delete zz
Next


For pp=1 To 12
For qq=1 To 9
If levtype<3
arwho(pp,qq)=0
ardir(pp,qq)=0
EndIf
;resets cats and mice (identical to setup function)
fu=full(pp,qq)
If fu>8 And fu<13 Then newmouse(pp,qq,fu-8)
If fu>12 And fu<17 Then newcat(pp,qq,fu-12)

Next
Next

testing=0
HideEntity ovpoint

;for stage mode, need to clear these arrows
cleararrows()

;for puzzle mode, need to reset arrows destroyed by cats
For pz.parrow=Each parrow
pz\size=2

ShowEntity pz\ent
ScaleEntity pz\ent,1,1,1
If pz\y<=9
ardir(pz\x,pz\y)=pz\face
EndIf

Next

If subtype=4 Then score(1)=0
If subtype=5 Then score(1)=20:score(2)=20
If subtype=6 Then score(1)=0:score(2)=0

If subtype>4
For ff=1 To 4
pointpos(ff,1)=basepos(ff,1)
pointpos(ff,2)=basepos(ff,2)
arnew(ff,0)=0
Next
EndIf

HideEntity wheel

End Function


Function showfail(xpos,ypos)

testing=3
ShowEntity ovpoint
PositionEntity ovpoint,xpos*4-22,0,24-ypos*4
ScaleSprite ovpoint,20,20
ovscale=20

animcats(0)

End Function


Function toptext(info$)
If testing=0 Then Color 255,255,0
If testing=1 Then Color 128,128,255
If testing=2 Then Color 0,255,0
If testing=3 Then Color 255,0,0
Text 352-StringWidth(info$)/2,5,info$
End Function


Function cleararrows()

For cc=1 To 4
For dd=1 To totarrows(cc)
HideEntity narrow(cc,dd)
arwho(arin(cc,dd,1),arin(cc,dd,2))=0
ardir(arin(cc,dd,1),arin(cc,dd,2))=0
full(arin(cc,dd,1),arin(cc,dd,2))=0
Next
totarrows(cc)=0
Next

End Function


Function everymove()

;place bases in intermediate positions

Local amdone#,mix1#,mix2#,amper#,height#

amdone=1500-(wontime-MilliSecs())
amdone=amdone/1500

amper=0.5+0.5*Sin(amdone*180-90)
height=Cos(amdone*180-90)


For i=1 To 4
mix1=basepos(i,1)*(1-amper)+basepos(isplace(i),1)*(amper)
mix2=basepos(i,2)*(1-amper)+basepos(isplace(i),2)*(amper)


PositionEntity bases(i),mix1*4-22,height*5,24-mix2*4


Next

End Function


Function clocker$(acd)

;acd = secs()
;the function turns this into clock form

If acd<=0 Then Return("0:00")

sw=acd
sy$=Str$(sw/60)
sz$=Str$(sw Mod 60)
While Len(sz$)<2
	sz$="0"+sz$
Wend

trr$=sy$+":"+sz$
Return(trr$)

End Function


;initialise paths for versus mode
;only carried out with new board
;based on walls, not arrow placements

Function f_route()

For i=1 To 4
For j=1 To 12
For k=1 To 9
route(i,j,k)=100
Next
Next
Next


For i=1 To 4
gendist(i,basepos(i,1),basepos(i,2),0)
Next

End Function


Function gendist(wbase,x,y,far)


If KeyHit(1) Then End

If route(wbase,x,y)<=far Then Return(0)
route(wbase,x,y)=far

For j=1 To 4
If wall(x,y,j)=0

nx=newx(x,j)
ny=newy(y,j)

gendist(wbase,nx,ny,far+1)

EndIf
Next

End Function




Function cpulook()

;function generates values for placing new arrows
;should take account of the fact that if there are three
;arrows already placed, placing a new one will result in an
;old one disappearing, so have to carry out this routine as
;if that first arrow isn't there (when totarrows(pl)=3)
;system doesn't take account of this



Local px,py

For pl=1 To 4

urgent(pl)=0
If stall(pl)>0 Then stall(pl)=stall(pl)-1
If cplay(pl)=5 And event=2 Then urgent(pl)=1 ;hates cats
If cplay(pl)=4 And event=1 Then urgent(pl)=1 ;loves mice

lscore(pl)=score(pl)

If subtype=5 Then lscore(pl)=100
;priorities for cat soccer (different scoring system)

posn(pl)=1

For pm=1 To 4
If score(pm)>score(pl) Then posn(pl)=posn(pl)+1
Next

Next



For pl=1 To 4

px=Int(pointpos(pl,1))
py=Int(pointpos(pl,2))

For i=1 To 12
For j=1 To 9
For k=1 To 4


arval(pl,i,j,k)=-(Abs(i-px)+Abs(j-px))/2

If full(i,j)>0 Then arval(pl,i,j,k)=-100 ;space is full
If arwho(i,j)<>pl Or optset(4)=0
If arwho(i,j)>0 Then arval(pl,i,j,k)=-100
EndIf

nk=newdir(i,j,k,k) ;1st k here (in direction) makes no difference

If nk=-1 Then arval(pl,i,j,k)=-100 ;this square is totally boxed in by walls

If nk>0

If nk<3 Then oppo=3-nk Else oppo=7-nk


lookdir=newdir(newx(i,nk),newy(j,nk),nk) ;looking at actual arrows this time

If lookdir=oppo Then arval(pl,i,j,k)=arval(pl,i,j,k)-5
;want to avoid mice/cats coming straight back, so don't aim them
;at an arrow which will send them straight back

EndIf

Next
Next
Next

Next


For pl=1 To 4

If cplay(pl)>=0

For c.catt=Each catt

apart=route(pl,c\x,c\y)
If apart<=8
cdist=apart
etype=3 ;cat
If c\dead=0 And c\magnet=0 Then comein(pl,c\nextx,c\nexty,c\face)
EndIf

Next


For m.mous=Each mous

apart=route(pl,m\x,m\y)
If apart<=8
cdist=apart
etype=m\special ;types of mouse
If m\dead=0 And m\magnet=0 Then comein(pl,m\nextx,m\nexty,m\face)
EndIf

Next

EndIf

Next



For pl=1 To 4

If cplay(pl)>=0

choices=0
topsco(pl)=-200


For i=1 To 12
For j=1 To 9
For k=1 To 4
If arval(pl,i,j,k)>=topsco(pl) Then topsco(pl)=arval(pl,i,j,k)
Next
Next
Next


If topsco(pl)>0

For i=1 To 12
For j=1 To 9
For k=1 To 4
If arval(pl,i,j,k)=topsco(pl)
choices=choices+1

io=i:jo=j:ko=k

If cplay(pl)=2
;mistake=1;Int(Rnd#(10)+0.5)
;If mistake=1 Then io=Int(Rnd#(12)+0.5):jo=Int(Rnd#(9)+0.5):ko=Int(Rnd#(4)+0.5)
EndIf


archo(choices,1)=io
archo(choices,2)=jo
archo(choices,3)=ko



EndIf
Next
Next
Next

EndIf


newchoice=0
If arval(pl,arwho(pl,1),arwho(pl,2),arwho(pl,3))<=0 Then newchoice=1
;If event=3 And totarrows(pl)=3 Then newchoice=0 ;placed arrows again
If cplay(pl)>3 And urgent(pl)=1 And stall(pl)>4 Then stall(pl)=4 ;performs at tough level
If stall(pl)>0 Then newchoice=0


If newchoice=1


;proposed arrow is no longer a good idea - make a new choice

If choices=0 Then arnew(pl,0)=0 ;don't place anything

If choices>0

nchoice=Int(Rnd#(choices)+0.5)

For l=1 To 3
arnew(pl,l)=archo(nchoice,l)
Next
arnew(pl,4)=arval(pl,arnew(pl,1),arnew(pl,2),arnew(pl,3)) ;value record
arnew(pl,0)=1
If cplay(pl)=1 Then stall(pl)=50 ;CPU weak
If cplay(pl)=2 Then stall(pl)=10 ;CPU average
If cplay(pl)=3 Then stall(pl)=4  ;CPU tough
If cplay(pl)>3 Then stall(pl)=15 ;loves mice / hates cats
EndIf

EndIf

EndIf

Next


End Function


Function humancon(pl)


If contype=0
For i=5 To 8
If KeyDown(ctrl(i)) Then ikey(i)=1
Next
EndIf

If design=0
For i=1 To 4
If KeyHit(ctrl(i)) Then ikey(i)=1
Next
EndIf

If contype=1
mx#=MouseXSpeed()
my#=MouseYSpeed()
MoveMouse 320,240
pointpos(pl,1)=pointpos(pl,1)+mx/40
pointpos(pl,2)=pointpos(pl,2)+my/40
EndIf

End Function


Function cpucon(pl)

Local px=pointpos(pl,1)
Local py=pointpos(pl,2)

If arnew(pl,0)=0 Then Return(0)

move=0
If px<arnew(pl,1) Then ikey(6)=1:move=1
If px>arnew(pl,1) Then ikey(5)=1:move=1
If py<arnew(pl,2) Then ikey(8)=1:move=1
If py>arnew(pl,2) Then ikey(7)=1:move=1

If move=0 Then ikey(arnew(pl,3))=1

End Function



Function comein(pl,x,y,dir)

;cpu routine
;combined comein and keepaway function

Local dist,merit#,found=0,yclose=0,ally#,love#=1,hate#=1

If cplay(pl)=4 Then love=3 ;loves mice
If cplay(pl)=5 Then hate=3 ;hates cats

;DebugLog("loop start (player "+pl+")")

For sk=1 To 8

;DebugLog("checking"+x+" "+y)

dist=route(pl,x,y)

If full(x,y)=0 And arwho(x,y)=0


acdir=newdir(x,y,dir) ;direction without arrows
yclose=tobase(pl,x,y,acdir,1) ;without arrows
;If pl=1 Then DebugLog("got "+yclose)

For sl=1 To 4
jj=newdir(x,y,dir,sl)
ox=x+adva(jj,1)
oy=y+adva(jj,2)
ndist=route(pl,ox,oy)


closest=tobase(pl,x,y,jj)
If ndist<dist Then mval=1 Else mval=-1

merit=1
If mval=1 And closest>0 Then merit=0.5
If mval=1 And closest>4 Then merit=0 ;hardly gets close at all
If mval=1 And yclose=0 Then merit=0.5 ;heading to base already - not so vital

;If pl=1 And mval=1 And merit=1 Then DebugLog(x+" "+y+" "+sl)

If mval=1 And pl=1 And etype=3 And merit>0
;DebugLog(yclose)
If yclose>0
EndIf
EndIf

If mval=1 And merit=1 Then found=1 ;path found - stop the search

If mval=-1 Then merit=merit*(0.9^sk)

If cplay(pl)=5 And etype=3 And mval=1 Then urgent(pl)=1 ;'hates cats'
If cplay(pl)=4 And etype>0 And etype<3 And mval=1 Then urgent(pl)=1 ;'loves mice'


;arrow will send mouse closer, but not directly into base
;still scores positive (needed for board 8 for example)

If etype<3 Then arval(pl,x,y,sl)=arval(pl,x,y,sl)+mouseval(etype)*mval*merit*love
If etype=3 Then arval(pl,x,y,sl)=arval(pl,x,y,sl)-lscore(pl)*mval*0.5*merit*hate
;sending mice towards your base
;and cats away from your base

For sm=1 To 4

If sm<>pl And cplay(sm)>=0


ally=-1
If teams=1 And Abs(sm-pl)=2 Then ally=1
;makes sure team-mates help each other out in team mode
If teams=0 Then attval#=attack(posn(pl))
If teams=1 Then attval#=1 ;takes away bias towards defence in team mode

If etype<3 Then arval(sm,x,y,sl)=arval(sm,x,y,sl)+mouseval(etype)*mval*attval*merit*ally
If etype=3 Then arval(sm,x,y,sl)=arval(sm,x,y,sl)-lscore(pl)*mval*0.5*attval*merit*ally

EndIf
;and mice away from enemy bases
;and cats towards enemy bases
;note - sm are potential attackers here and pl is the victim
Next


Next

EndIf

dir=newdir(x,y,dir)
x=newx(x,dir)
y=newy(y,dir)

If dist=0 Or found=1 
;DebugLog("loop end")
Exit;end loop
EndIf

Next

End Function






Function newx(ax,dir)
ax=ax+adva(dir,1)
If ax=0 Then ax=12
If ax=13 Then ax=1
Return(ax)
End Function


Function newy(ay,dir)
ay=ay+adva(dir,2)
If ay=0 Then ay=9
If ay=10 Then ay=0
Return(ay)
End Function


Function tobase(pl,ux,uy,udir,show=0)

close=20

;sees if an arrow placement will guide mice straight to your base
;(or cats to the opponent's)

If route(pl,ux,uy)=0 Then Return(0) ;direct route

For sz=1 To 8

ux=newx(ux,udir)
uy=newy(uy,udir)

;If show=1 Then DebugLog(ux+" "+uy)


If route(pl,ux,uy)=0 Then Return(0) ;direct route

If full(ux,uy)=17 Then Return(close) ;fell into a hole


If route(pl,ux,uy)<close Then close=route(pl,ux,uy)


udir=newdir(ux,uy,udir)

Next

Return(close)

End Function


Function initmouse(m.mous)
m\face=newdir(m\x,m\y,m\face,ardir(m\x,m\y))
m\nextx=newx(m\x,m\face)
m\nexty=newy(m\y,m\face)
m\adjust=1
End Function

Function initcat(c.catt)
c\face=newdir(c\x,c\y,c\face,ardir(c\x,c\y))
c\nextx=newx(c\x,c\face)
c\nexty=newy(c\y,c\face)
c\adjust=1
End Function

Function textscore(scor,x,y,gap,all=1)
;x,y are the co-ords of the digit part of the number

Local s1=scor

For i=1 To 3 ;3 digits displayed
sunit=s1 Mod 10
Text x,y,sunit
s1=s1/10
x=x-gap
If s1=0 And all=0 Then Exit ;don't show leading zeros
Next

End Function


Function update_camera()

Local tuz#

If panning=0 Then tuz=90
If panning=1 Then tuz=130+tux/2 

PositionEntity camera,EntityX(campivot2,True),EntityY(campivot2,True),EntityZ(campivot2,True)
RotateEntity camera,tuz,tuy,180

End Function


Function camera_pan()

tuxx=(tuxx+Rnd#(0.01)-0.005+(40-tux)/1000)
tux=tux+tuxx
tuy=tuy+1.5

tumm=(tumm+Rnd#(0.01)-0.005+(15-tum)/500)
tum=tum+tumm

RotateEntity campivot,tux,tuy,0
PositionEntity campivot2,0,20-tum/2,0

End Function


Function rem_timers()
rem_gametime=gametime-MilliSecs()
rem_wontime=wontime-MilliSecs() ;events
rem_surtime=surtime-MilliSecs() ;survival

For i=1 To 4
For j=1 To 3
rem_artime(i,j)=arin(i,j,4)-MilliSecs() ;arrows
Next
Next

For pp.pic=Each pic
pp\rem_time=pp\time-MilliSecs() ;allright,ouch
Next

End Function


Function fix_timers()
;can fix timers if wheel is in motion, as well as when paused

gametime=MilliSecs()+rem_gametime
surtime=MilliSecs()+rem_surtime

If paused=1 Then wontime=MilliSecs()+rem_wontime ;events

If paused=0 And panning=1 Then Return(0)

For i=1 To 4
For j=1 To 3
arin(i,j,4)=MilliSecs()+rem_artime(i,j) ;arrows
Next
Next

If paused=0 And wheelat<1 Then Return(0)

For pp.pic=Each pic
pp\time=MilliSecs()+pp\rem_time ;allright,ouch
Next

End Function


Function saverecords()

;include challenge mode stage reached here

sev=WriteFile("churecs.dat")

WriteInt sev,chalev
For i=1 To 125
WriteInt sev,passed(i)
Next
For j=1 To 25
WriteInt sev,stagerec(j)
WriteInt sev,survrec(j)
Next

CloseFile sev

End Function


Function loadrecords()

lod=ReadFile("churecs.dat")

If lod=0 Then Return(0)

chalev=ReadInt(lod)
For i=1 To 125
passed(i)=ReadInt(lod)
If i<=100 And passed(i)=1 Then tpassed=tpassed+1
Next

For j=1 To 25
stagerec(j)=ReadInt(lod)
survrec(j)=ReadInt(lod)
Next

CloseFile lod

End Function


Function name$(who)

If who>4 Then Return(plname$(who))
If cplay(who)=0 Then Return(plname$(who))
If cplay(who)>0 Then Return("CPU")
If cplay(who)=-1 Then Return("Vacant")
If cplay(who)=-2 Then Return("CPU")
If cplay(who)=-3 Then Return("Vacant")

End Function


Function round_info(who,xpos,ypos)

Color 0,0,0
Rect xpos-2,ypos-2,144,69

Color 255,255,255
Rect xpos,ypos,140,65
SetFont font4

For j=1 To tot_rounds
If j>won(who) Then DrawImage drocket(0),xmap(xpos,j),ypos+2
If j<=won(who) Then DrawImage drocket(who),xmap(xpos,j),ypos+2
Next

ryto=ypos+2

End Function


Function into_pan()

panning=1
For i=1 To 4
full(basepos(i,1),basepos(i,2))=17
HideEntity bpoint(i)
HideEntity bcrown(i)
;bases act like holes once the round is over
Next

HideEntity ssign

End Function


Function new_atom(xpos,ypos)

at.atomex=New atomex
at\ent=CopyEntity(atom)
PositionEntity at\ent,xpos*4-22,0,24-ypos*4
at\light=CreateLight(2,at\ent)

at\extime=MilliSecs()+1000
If survival=1 Then PlaySound atomic

End Function


Function do_survival()

Local highest=0

For i=1 To 4

If score(i)>highest Then highest=score(i)

If cplay(i)=-2
score(i)=score(i)+1
If i=1 Then limit=100 Else limit=50

If score(i)>=limit
cplay(i)=oplay(i)
ShowEntity bases(i)
full(basepos(i,1),basepos(i,2))=i

EndIf
EndIf
Next


If highest<=100 Then surlimit=200
If highest>100 Then surlimit=20000/highest
;the higher the top score, the faster points are cut from everyone
;stops game becoming tedious, especially after mouse mania

If MilliSecs()-surtime>surlimit

surtime=MilliSecs()
rem_surtime=0

For i=1 To 4

If cplay(i)>-2
score(i)=score(i)-1
If score(i)<=0
score(i)=0


If i>1
oplay(i)=cplay(i)
cplay(i)=-2 ;empty base

If foes=3 Then score(1)=score(1)+15
If foes=2 Then score(1)=score(1)+20
If foes=1 Then score(1)=score(1)+40

;reward for out_lasting an opponent
;helps to prolong the game
EndIf


HideEntity bases(i)
full(basepos(i,1),basepos(i,2))=17

new_atom(basepos(i,1),basepos(i,2))
If i>1 Then beaten=beaten+1
If i=1 And challenge=0 Then into_pan()
If i=1 And challenge=1 Then cvictory=-1
If i=1 And challenge=0 And custom=0
If beaten>survrec(boardnum) Then survrec(boardnum)=beaten
EndIf

EndIf
EndIf
Next

EndIf


End Function


Function extras()

;base explosions in survival mode
For at.atomex=Each atomex
done#=1100-(at\extime-MilliSecs())
done#=done#/1000
scale#=Sin(done#*180)*5

EntityAlpha at\ent,(1.1-done#);^0.5

ScaleEntity at\ent,scale,scale,scale
TurnEntity at\ent,5,5,5

If done#>1
FreeEntity at\ent
Delete at
EndIf

Next


;stars move in background
stx=stx+stxx
sty=sty+styy

stxx=(stxx+Rnd#(0.01)-0.005-stx/10000)
styy=(styy+Rnd#(0.01)-0.005-sty/10000)

stxx=stxx*0.999
styy=styy*0.999

TurnEntity space,stxx*5,styy*5,0


End Function



Function pause_stuff()

tomenu=0
If paused=0
If KeyHit(1) Then tomenu=1

If design=0 And cvictory=0 And testing<=1 And levtype=1
If levtype+challenge=1 Or testing>0 Or paused=1
If MouseHit(1) Then tomenu=1
If MouseHit(2) Then tomenu=1
EndIf
EndIf
EndIf

If paused=1 Or design=1
If KeyHit(1)
backtomenu()
Return(0)
EndIf
EndIf


If paused=1
If MouseHit(1) ;resume
FlushMouse()

If panning=0
paused=0
If testing=1 And wheelat<1 Then animcats(1)

If musc<>0
ResumeChannel musc
EndIf
EndIf


If panning=1
;moving to next stage for versus
PositionEntity campivot,0,0,0
RotateEntity campivot,0,0,0
PositionEntity campivot2,0,35,0
StopChannel musc ;ready to start it again
panning=0
testing=2 ;triggers boardnum=boardnum+1
trigger=1 ;triggers goahead
maincontrol()
EndIf


EndIf

If MouseHit(2) ;restart
initialise()

StopChannel musc
PositionEntity campivot,0,0,0
RotateEntity campivot,0,0,0
PositionEntity campivot2,0,35,0
RotateEntity light,90,0,0
;update_camera()
EndIf

EndIf


If paused=0
If tomenu=1
FlushKeys()
FlushMouse()
paused=1
animcats(0)

If musc<>0
PauseChannel musc
EndIf

;whenever game is frozen, current timer states must be noted
rem_timers()
EndIf
EndIf


End Function



Function result()


;testing = 2  means victory
;testing = 3  means defeat

If modetype=2 And mice=0 Then testing=2 ;puzzle mode included in modetype 2
If subtype=4 And score(1)>=100 Then testing=2
If levtype=2 And gametime<MilliSecs() Then testing=3
If subtype=5 And score(2)<=0 Then testing=2
If subtype=5 And score(1)<=0 Then testing=3
If subtype=6 And score(1)>=score(2)+100 Then testing=2
If subtype=6 And score(1)<=score(2)-100 Then testing=3
If testing=2 Or testing=3 Then animcats(0)

If testing=2 And levtype=2 And custom=0 And design=0
yourtime=(totaltime-(gametime-MilliSecs()))/1000
If yourtime<stagerec(boardnum) Then stagerec(boardnum)=yourtime
EndIf

If testing=2 Or testing=3 Then rem_timers()
;record time taken for stage mode

If testing=2 And levtype=3 And custom=0 And design=0
If passed(puzd*25+boardnum-25)=0 Then tpassed=tpassed+1
passed(puzd*25+boardnum-25)=1
EndIf

If levtype=2 And testing=2 Then passed(100+boardnum)=1

If challenge=1

bestfoe=score(2)
If score(3)>bestfoe Then bestfoe=score(3)
If score(4)>bestfoe Then bestfoe=score(4)

lead=score(1)-bestfoe

If gtype=1 And lead>=gtarget Then cvictory=1
For i=1 To 4
madeit=0
If gtype=2 And score(i)>=gtarget And posn(i)=1 Then madeit=1
If madeit=1 And i=1 Then cvictory=1
If madeit=1 And i>1 Then cvictory=-1
Next

If gtype=3 And beaten>=gtarget Then cvictory=1

If gametime<MilliSecs()
If gtype<4 Then cvictory=-1
If gtype=4 And lead>=gtarget Then cvictory=1
If gtype=4 And lead<gtarget Then cvictory=-1
If gtype=5 Then cvictory=1 ;survived for set time
EndIf



If cvictory<>0
into_pan()
If cvictory=1 Then winner=4:inf$="CHALLENGE PASSED"
If cvictory=-1 Then winner=3:inf$="CHALLENGE FAILED"

EndIf

EndIf

End Function



Function signs()

;'time left' sign control

If totaltime-(gametime-MilliSecs())>1000
If signz<-1 Or signz>30
If abstime(120) Then newsign(twomin,6,2,0.2)
If abstime(60) Then newsign(onemin,6,2,0.2)
If abstime(30) Then newsign(thirty,6,2,0.2)
If abstime(3) Then newsign(three,5,5,0.5)
If abstime(2) Then newsign(two,5,5,0.5)
If abstime(1) Then newsign(one,5,5,0.5)
EndIf
EndIf

If signz>=-1 And signz<=30

signz=signz+signdz
PositionEntity ssign,signz/10,signz/10,signz
If testing=1 Then EntityAlpha ssign,0.95-signz/40
If testing=1 And signz>25 Then signz=40

If signz<-1 Then HideEntity ssign
If signz>30 Then HideEntity ssign
EndIf

End Function


Function newsign(newtex,wide,high,speed#,zpos=-1)

ShowEntity ssign
EntityTexture ssign,newtex
ScaleSprite ssign,wide,high
EntityAlpha ssign,1
signz=zpos
signdz=speed

End Function


Function abstime(secs)
If Abs(gametime-MilliSecs()-secs*1000)<20 Then Return(True)
Return(False)
End Function



Function save_opts()

sev=WriteFile("chu_options.dat")

WriteInt sev,tot_rounds
For i=1 To 4
WriteInt sev,optset(i)
WriteInt sev,plcho(i)
WriteInt sev,cpcho(i)
Next

CloseFile sev

End Function


Function load_opts()

lod=ReadFile("chu_options.dat")

If lod=0 Then Return(0)

tot_rounds=ReadInt(lod)
For i=1 To 4
optset(i)=ReadInt(lod)
plcho(i)=ReadInt(lod)
cpcho(i)=ReadInt(lod)
Next

CloseFile lod

End Function


Function xmap(xat,lpos)

Return(xat+140*lpos/(tot_rounds+1)-16)

End Function


Function getchal()

For i=1 To 4
cplay(i)=chadata(chalev,i)
Next

chatime=chadata(chalev,5)*1000

boardnum=chadata(chalev,8) ;arena for challenge

gtype=chadata(chalev,6)
gtarget=chadata(chalev,7)
survival=0
If gtype=3 Or gtype=5 Then survival=1

End Function


Function initialise()

clearboard()
newboard()
loadlevel(boardnum)
setup()
show()
f_route() ;setup routes for AI

End Function


Function reset_camera()

If ingame=0
AmbientLight 255,255,255
PositionEntity campivot,-25,0,23
RotateEntity campivot,0,0,0
PositionEntity campivot2,0,55,0
RotateEntity light,-90,0,0
EndIf

If ingame=1
AmbientLight 0,0,0
PositionEntity campivot,0,0,0
RotateEntity campivot,0,0,0
PositionEntity campivot2,0,35,0
RotateEntity light,90,0,0
EndIf

End Function


Function winstuff()

For i=0 To 600 Step 40
DrawImage drocket(xwinner),i,0
DrawImage drocket(xwinner),i,420
Next

For j=60 To 360 Step 60
DrawImage drocket(xwinner),0,j
DrawImage drocket(xwinner),600,j
Next

For i=1 To 5
DrawImage congrats,90,40+i*45
Next

SetFont font8
victor$=Upper$(plname$(xwinner))
Color basecol(xwinner,1),basecol(xwinner,2),basecol(xwinner,3)
Text 320-StringWidth(victor$)/2,320,victor$

End Function


Function backtomenu()

HideEntity space

FlushKeys()
FlushMouse()
ingame=0
For i=1 To 6
won(i)=0 ;reset round wins for versus mode
Next
StopChannel musc
checkexists()
clearboard()

dorefresh=0
If challenge+watching=0 Then dorefresh=1
If challenge+watching>0 Then levtype=0

;if challenge=1 or watching=1, going back to main titles, so don't show map

watchtimer=MilliSecs()

End Function


Function quadrant(xp,yp,who)

Color basecol(who,1),basecol(who,2),basecol(who,3)
Rect xp,yp,220,35
xlpos=5
If who=2 Or who=4 Then xlpos=145

Color 0,0,0
Rect xp+xlpos,yp+7,70,20
SetFont font4
Color 255,255,255
Text xp+xlpos+5,yp+7,name$(who)

End Function


Function rquad(xp,yp,who)

Color basecol(who,1),basecol(who,2),basecol(who,3)
Rect xp,yp,320,50
xlpos=10
If who=2 Or who=4 Then xlpos=200

Color 0,0,0
Rect xp+xlpos,yp+10,110,30
SetFont font7
Color 255,255,255
Text xp+xlpos+7,yp+10,name$(who)

End Function


Function reset_time()

If levtype=2 Then gametime=MilliSecs()+60000
If subtype=6 Then gametime=MilliSecs()+120000
If levtype=1 And challenge=0 Then gametime=MilliSecs()+60000*optset(1)
If levtype=1 And challenge=1 Then gametime=MilliSecs()+chatime
totaltime=gametime-MilliSecs()

rem_timers() ;remember time left

End Function


Function animcats(active)

Local cspeed#

If active=0 Then cspeed=0
If active=1 Then cspeed=cat_speed*factor*7

For c.catt=Each catt
Animate(c\anima,1,cspeed)
Next

End Function